2002-08-19  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION: release 1.6.0 

	* make/lilypond.redhat.spec.in: don't dist input/ separately
	anymore

	* Documentation/user/latex-example.latex: restore from old version

	* Documentation/topdocs/index.tely: remove @settitle

	* Documentation/topdocs/README.texi: small fixes.

	* lily/self-aligment-interface.cc (centered_on_parent): only
	return center if extents not empty.

	* scm/music-functions.scm (unfold-repeats): typo,  

	* mf/feta-bolletjes.mf: use resolution independent variables.

2002-08-19  janneke  <janneke@blauw.xs4all.nl>;

	* lily/stem.cc (calc_stem_info): Fix [a8 a32].

	* Documentation/index.texi (Top): Templates url fix, small url
	name changes.

	* regular-spacing-engraver.cc:
	* scm/grob-property-description.scm: Remove regular-distance-to.

	* input/test/spacing-regular.ly:
	* lily/regular-spacing-engraver.cc: Remove.

2002-08-18  janneke  <janneke@blauw.xs4all.nl>

	* mensural-ligature.cc: *** empty log message ***

	* tab-note-heads-engraver.cc: * lily/tab-note-heads-engraver.cc:
	* scm/translator-property-description.scm: Add tablatureFormat.

	* input/test/staff-bracket.ly: Update.

	* regular-spacing-engraver.cc:
	* lily/regular-spacing-engraver.cc: Add regular-distance-to.

	* ligature-bracket.cc, ligature-engraver.cc, ligature-head.cc,
	mensural-ligature-engraver.cc, mensural-ligature.cc:

	* lily/mensural-ligature-engraver.cc:
	* scm/grob-property-description.scm: Add head-width, join-left,
	primitive.

2002-08-18  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* ambitus.cc, parser.yy:
	* Documentation/user/introduction.itely: small corrections.

	* lily/parser.yy (property_def): Ugh. Switch off
	internal-type-checking for autoBeamSettings.

2002-08-18  janneke  <janneke@blauw.xs4all.nl>

	* music.cc (internal_set_mus_property): [!NDEBUG] Remove, use
	abort instead of assert.

2002-08-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	* scm/grob-property-description.scm: Remove regular-distance-to.

	* input/test/spacing-regular.ly:
	* lily/regular-spacing-engraver.cc: Remove.
	
2002-08-19  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* input/mutopia/J.S.Bach/wtk1-fugue2.ly: staff switch fixes.

	* Documentation/user/lilypond-book.itely: small cleanups

	* Documentation/user/*.itely: fix overfull hboxes. 

2002-08-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/user/tutorial.itely (A piano excerpt): 
	* Documentation/user/introduction.itely (Introduction): Typo fix.

	* input/test/header-ifelse.ly: Bugfix: call numbers->string only
	on first three elements of ly-version list.

	* input/test/trills.ly: Comment out \comma.

	* lily/tab-note-heads-engraver.cc: 
	* scm/translator-property-description.scm: Add tablatureFormat.

	* input/test/staff-bracket.ly: Update.

	* lily/regular-spacing-engraver.cc: Add regular-distance-to.

	* input/test/orchestscore.ly:  
	* input/test/part-combine-moments.ly:
	* input/test/part-combine-staff.ly: markScriptPadding ->
	RehearsalMark #'padding.

2002-08-19  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* Documentation/user/introduction.itely: small corrections.

	* scm/translator-property-description.scm (tablatureFormat):
	describe property.

	* lily/parser.yy (property_def): Ugh. Switch off
	internal-type-checking for autoBeamSettings.

2002-08-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/mensural-ligature-engraver.cc:
	* scm/grob-property-description.scm: Add head-width, join-left,
	primitive.
	
	* lily/mensural-ligature.cc: 
	* lily/ligature-bracket.cc: 
	* scm/grob-property-description.scm: 

	* lily/ligature-head.cc: Add ligature-primitive-callback.

	* input/test/beam-control.ly: 
	* input/test/bar-script-visibility.ly: Update.

	* lily/music.cc (internal_set_mus_property): [!NDEBUG] Remove, use
	abort instead of assert.

2002-08-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	* input/test/ambitus.ly: Comment out ambitus until anal-proof.

	* buildscripts/mf-to-table.py (write_fontlist): change
	extra-extent-X extra-X-extent.

	* scm/music-property-description.scm (label): Typecheck markup?
	(was string?).

	* Documentation/user/refman.itely (Tablatures basic): Change
	TabStaff @lilypond snippets to @example until TabStaff is
	anal-proof.

2002-08-18  Rune Zedeler <rune@zedeler.dk>

	* mf/feta-klef.mf: (another) white pixels bug in g-clef fixed.
	
2002-08-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/include/lily-guile.hh (LY_DEFINE_NOARGS): Remove.

	* lily/grob-property.cc (internal_set_grob_property): Revert oops.

	* lily/input.cc (message): 
	* flower/warn.cc (message): Flush output.

	* po/lilypond.pot: Run make po-replace.

	* Documentation/user/GNUmakefile (LILYPOND_BOOK_FLAGS): be anal
	with type checks.

	* Documentation/GNUmakefile (LILYPOND_BOOK_FLAGS): 
	* input/regression/GNUmakefile (LILYPOND_BOOK_FLAGS):
	* input/test/GNUmakefile (LILYPOND_BOOK_FLAGS): 
	* Documentation/user/invoking.itexi: 
	* lily/scm-option.cc:
	* lily/main.cc: Debugging options: ly-set-option (was:
	set-lily-option).

	* lily/scm-option.cc (ly_option_usage): New function.

2002-08-18  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/parser.yy (script_abbreviation): accept -_ script.

	* ly/script-init.ly (dashUnderscore): add NOTE-_ == portato (dash
	and dot)

	* scripts/lilypond-book.py (re_dict): add spaces after command sequences
	(LatexPaper.find_latex_dims): run latex in nonstopmode

	* input/font-body.ly: remove.

	* input/test/harmonic.ly: new file.

	* lily/side-position-interface.cc (aligned_side): don't add
	padding again.

2002-08-18  Werner Lemberg  <wl@gnu.org>

	* ly/engraver-init.ly:
	s/extraverticalExtent/extraVerticalExtent/.
	
2002-08-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/parser.yy (assignment, Simple_music): Warning message fix.
	Junk ARRAY_SIZE definition.

	* lily/score-engraver.cc: Uniformise error message.

	* lily/grob-property.cc (internal_set_grob_property,
	internal_get_grob_property): [!NDEBUG] Remove, use abort instead
	of assert; we always want this functionality.  Uniformise warning
	message.
	
	* lily/main.cc (main, main_prog): Bugfix: move exit-upon-files
	back, until after evaluating init_scheme_code.

	* scm/translator-property-description.scm (breakAlignOrder): Doco fix.

	* Documentation/user/lilypond-book.itely: Remove @cindex
	without argument.

	* Documentation/user/internals.itely: Remove stray comma after
	@cindex entry.

2002-08-18  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION: 1.5.74 released  

	* lily/break-substitution.cc (fast_fubstitute_grob_list): use
	realloc()

	* lily/dynamic-engraver.cc (process_music): don't use SCM_UNDEFINED

	* Documentation/user/tutorial.itely: fixes by Graham Percival.

2002-08-17  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/lily-guile.cc (type_check_assignment): if
	internal-type-checking set, abort if we find an unknown property.

	* input/regression/GNUmakefile,input/test/GNUmakefile: be anal
	with typechecks

	* lily/beam.cc: add 'knee to interface

	* input/test/*.ly: remove or update files using deprecated
	properties

	* lily/system.cc (spanner_count): new function

	* lily/break-substitution.cc (fast_substitute_grob_list): special
	function for break substitutions on groblists in spanners. By
	reordering the elements of the list, we can skip large parts of
	the list in the break substitution. This brings the complexity of
	Lily back to more-or-less linear in the length of the score.

	Measured speed increase: 20 % (coriolan, without -O2)

	* lily/parse-scm.cc (parse_handler): don't construct a new strport
	for every parsing. This saves a lot of garbage on large files that
	have many # constructs.

	* lily/source-file.cc (init_port): add an SCM port to the
	sourcefile as well. 

	* lily/include/input-file-results.hh: move from
	file-results. Rename Input_file_settings to Input_file_results.

	* flower/ : remove simple-file-storage, mapped-file-storage,
	string-storage. Move source-file, binary-source-file to lily/

	* Documentation/header.html.in: remove FAQ

	* Documentation/index.texi (Top): reorganise

	* Documentation/topdocs/INSTALL.texi (Top): add note about fonts.

	* Documentation/topdocs/FAQ.texi: remove.

	* stepmake/stepmake/documentation-targets.make (footify): must
	depend on all .html files, otherwise rebuilds are broken due to
	the time stamps 

	* ly/declarations-init.ly (noBreak): set penalty to 10001 (>
	10000).

2002-08-16  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* ly/engraver-init.ly (ChordNamesContext): minimumverticalExtent
	-> minimumVerticalExtent

2002-08-16  Stephen Peters <portnoy@portnoy.org>

	* scm/pdf.scm, pdftex.scm: pdftex updates

	* scripts/ly2dvi.py: pdflatex support
	
2002-08-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/windows/installing.texi: Include info from Wiki. 

2002-08-16  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

	* scripts/lilypond-book.py (output_dict): Replace
	\includegraphics{xxx.eps} -> \includegraphics{xxx} to 
	simplify for pdflatex users (makes no difference to latex users).

2002-08-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/index.texi: 
	* Documentation/windows/compiling.texi: 
	* Documentation/windows/installing.texi: Update to reflect
	LilyPond's inclusion into Cygwin.

2002-08-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	* input/test/phrasing-slur-height.ly: New file.

	* scm/grob-property-description.scm (height-limit, ratio): Add.

	* lily/slur.cc: 
	* scm/grob-description.scm (Slur, PhrasingSlur): Move height-limit
	and ratio out of details.

	* lily/scores.cc (Input_file_settings): Initalize global_header_.

	* lily/include/file-results.hh (class Input_file_settings): Add
	private constructor.

	* cygwin/GNUmakefile: [CYGWIN] Install bug-lilypond-cygwin.  Typo
	fix.  Add kpsewhich commands (Thanks Mats).

	* cygwin/bug-lilypond-cygwin.sh: New file.

	* stepmake/stepmake/help2man-rules.make: Better way of showing
	help2man command.

	* Documentation/topdocs/FAQ.texi: Add more possible stale font
	paths.

	* stepmake/bin/package-diff.py: Prepend ./ to cut-and-pastable
	commands.

	* Documentation/topdocs/INSTALL.texi: Mention the need to and how
	to create configure for CVS source trees.  Mention libkpathsea-dev
	as alternative possible name for tetex-devel (or should that be
	the other way around?).

2002-08-15  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/include/file-results.hh (class Input_file_settings):
	encapsulate file settings in a class, Input_file_settings.

	* lily/scores.cc: new function ly_set_point_and_click_x
	
	* Documentation/topdocs/README.texi (Top): add note about xdelta

	* Documentation/topdocs/INSTALL.texi (Top): move kpathsea to problems
	section.
	
2002-08-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	* scripts/ly2dvi.py: Remove debug printing.

2002-08-14  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* scripts/convert-ly.py (FatalConversionError.conv): bug in
	verticalExtent replacement.

	* VERSION: 1.73 released.

2002-08-14 <jiba@tuxfamily.org>

	* scm/output-lib.scm: Support of hammers and pulls in tablature
	-- Hammers and pulls are inserted exactly like slurs, and a "H" or
	a "P" is added over the slur as needed.  

	* ./input/test/tablature-hammer.ly: example of hammer, pull and
	legato in a tablature.

	* ly/engraver-init.ly: Stem.up-to-staff is now disabled by
	default, since it appears that most of the published tablatures
	are not like that.

2002-08-13  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/beam.cc (brew_molecule): use
	Staff_symbol_referencer::staff_space for thickness.

2002-08-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/user/lilypond.tely: Add dir entries for
	executables.

	* Documentation/user/converters.itely: 
	* Documentation/user/invoking.itexi: Fix `invocation' node names,
	in line with standard dir entries.

	* Documentation/user/convert-ly.itexi
	* Documentation/user/ly2dvi.itexi: Remove.
	
	* scripts/ly2dvi.py: Add pseudo-filter (and stdout output)
	support.

	* lily/main.c: 
	* lily/paper-score.cc : 
	* lily/gourlay-breaking.cc: Write info to stderr.

	* buildscripts/help2man.pl: Update to latest version from Debian.
	Fixes generation of man pages with perl 5.6.1.

	* GNUmakefile.in: Add python link to build-datadir.  Fixes
	generation of midi2ly man page.

2002-08-14  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

	* Documentation/user/{tutorial.itely, introduction.itely}: 
	Small fixes.

2002-08-13  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/beam.cc (least_squares): Add comment.

	* input/regression/beam-center-slope.ly: Update.

	* lily/beam-quanting.cc (score_stem_lengths): Revert oops.

	* input/template/melody-chords.ly: New file.

	* lily/stem.cc (calc_stem_info): Move, document, clean up and fix
	up-to-stem feature.

	* ly/grace-init.ly (startGraceMusic):
	* scm/grob-description.scm (beamed-lengths): Subtract half a beam
	thickness, to fix most ugly beams.  See input/test/stem.ly and
	baerenreiter-sarabande.ly.

	* input/test/stem.ly:
	* input/mutopia/J.S.Bach/baerenreiter-sarabande.ly: Play with
	beamed-lengths.

	* input/test/spacing.ly: Give enough room to test spacing.

	* cygwin/post-lilypond.sh: Fix and update.

	* cygwin/zlily-profile.sh: Remove.

2002-08-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	* GNUmakefile.in (EXTRA_DIST_FILES): Add server.el.patch.

	* scm/grob-property-description.scm
	(beamed-extreme-minimum-free-lengths): New property, now correctly
	named.

	* ly/grace-init.ly: New beam property updates.

	* input/les-nereides.ly: Updates.

	* cygwin/README.in: New file.

	* input/sondag-morgen/GNUmakefile: 
	* input/mutopia/R.Schumann/GNUmakefile: New file.

	* scm/grob-property-description.scm (beamed-minimum-free-lengths):
	(beamed-extreme-free-lengths): New property.

	* lily/beam.cc (forced_stem_count): Count boundary cases too.
	(set_stem_shorten): Integer divide bug fix.

	* input/mutopia/J.S.Bach/baerenreiter-sarabande.ly: Really expect
	six systems, change warning into error.

	* scm/grob-description.scm (beamed-stem-shorten): Shorten 8th
	beams same as normal stem (one staffspace), high order beams less
	(arbitrary guess).
	(beamed-lengths): Standard length for all beams.
	(beamed-minimum-free-lengths):
	(beamed-extreme-minimum-free-lengths): New property.

	* input/regression/beam-default-lengths.ly: 
	* input/regression/beam-shortened-lengths.ly: New file.

	* lily/stem.cc (get_stem_info): New function.
	(calc_stem_info): Partial rewrite.

	* scm/grob-description.scm (Beam): same beamed-stem-shorten for
	all beam counts.

2002-08-12  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION: 1.5.72 released

	* input/sondag-morgen/GNUmakefile (examples): add file

	* input/mutopia/R.Schumann/GNUmakefile (examples): add file
	
	* lily/lily-guile.cc (to_dir): return CENTER if not a direction.

	* lily/include/grob.hh: remove remove_grob_property()

	* lily/stem-engraver.cc (stop_translation_timestep): remove
	dir-forced grob property

	* Documentation/user/refman.itely (Grace notes): explain grace
	after main note.

	* input/test/ : small convert-ly mishaps.

	* Documentation/user/preface.itely: small bits 

	* Documentation/user/introduction.itely: add sectioning

2002-08-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/stem.cc (get_default_stem_end_position): use beam_count - 1
	as index; this fixes too short forced stem directions.
	(calc_stem_info): various minute bugfixes.  

	* lily/gourlay-breaking.cc (combine_demerits): set uniform
	tightness constraint back to one. This fixes Baerenreiter
	sarabande layout.

	* input: some fixes. Add \version to all files.
	
	* lily/stem.cc (calc_stem_info): Use get_direction_beam_count.

	* lily/beam.cc (get_direction_beam_count): New function.

	* GNUmakefile.in: Fix config.h dependency.

	* input/test/beam-dir-function.ly: Fix for new default
	neutral-direction = -1 (down).

	* input/regression/tuplet-properties.ly:
	* input/regression/tuplet-nest.ly: Fix.

	* lilypond-font-lock.el (LilyPond-font-lock-keywords):
	* input/test/improv.ly:
	* input/test/cautionaries.ly: Accidentals -> Accidental.

	* input/test/add-text-script.ly: Bugfix.  How did this ever work?

	* Documentation/windows/installing.texi: 
	* Documentation/windows/compiling.texi:
	* cygwin/README: Update to reflect new binary release setup and
	build instructions.

2002-08-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	* server.el.patch: Update.

2002-08-10  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* stepmake/stepmake/metafont-rules.make: pktrace -> mftrace name
	change.
	* configure.in: idem

2002-08-10  Juergen Reuter  <reuter@ipd.uka.de>

	* mf/parmesan-timesig.mf, scm/output-lib.scm,
	lily/include/time-signature.hh, lily/time-signature.cc,
	input/test/time.ly: fixed broken time-signature by setting grob
	property font-family automatically.

2002-08-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/user/tutorial.itely (Running LilyPond): Mention
	xdvi and XFree86 option for Windows users.

	* Documentation/user/invoking.itexi: Add ly2dvi's -p alias.

	* scripts/ly2dvi.py: Bugfix for `ly2dvi -I ./foo foo.ly'.  Also
	append directory of first file to search path, allowing
	`ly2dvi	foo/foo.ly' when foo.ly includes other files from
	directory foo.  Add short option alias '-p' for --pdf.

	* input/test/trills.ly: 
	* input/test/preset-extent.ly: 
	* scm/grob-property-description.scm: more extent renaming.

2002-08-09  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/parse-scm.cc (protected_ly_parse_scm): compatibility with
	CVS GUILE 

	* input/test/preset-extent.ly (texidoc): added file.

	* scripts/convert-ly.py: add extent rule.

	* lily/grob.cc: change extent-[XY] to [XY]-extent globally.

2002-08-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/main.cc (main): Remove stale #ifdef for windows.

	* stepmake/stepmake/python-module-rules.make: 
	* stepmake/stepmake/python-module-vars.make: 
	* stepmake/stepmake/shared-library-vars.make: Add Cygwin support.

	* stepmake/stepmake/generic-vars.make:
	* cygwin/GNUmakefile: Fix Cygwin build detection.
	
	* stepmake/stepmake/shared-library-rules.make: Remove version juggling.

	* stepmake/stepmake/shared-library-targets.make: Default target
	includes version, add target libFOO.

	* lily/main.cc: Temporary fix for access to scm_read_opts array
	from shared Cygwin library.

2002-08-08  Rune Zedeler <rune@zedeler.dk>
	
	* ly/property-init.ly: Added phrasingSlurUp, phrasingSlurDown and
	phrasingSlurBoth.

	* input/mutopia/R.Schumann/romanze-op28-2.ly: Added.

	* input/sondag-morgen/*: renamed files from input/SondagMorgen/*
	
2002-08-08  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/beam.cc (struct Int_set): typo.

	* mf/feta-beugel.mf (code): braces should start at 0, not 1.

	* lily/include/lily-guile.hh (scm_int2num): guile 1.4 compatibility. 

	* scm/grob-description.scm (all-grob-descriptions): set
	X-offset-callbacks for TextScript

	* lily/stem.cc (invisible_b): don't use support_head(), since it
	sets stem direction.

	* lily/beam.cc (struct Int_set): don't get stuck inserting
	interval segments of length 0.0.

	* scripts/convert-ly.py:  break-align conversion.

2002-08-06  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/*.cc (process_music): gh_int2scm -> scm_int2num

2002-08-06  Heikki Junes <hjunes@cc.hut.fi>

	* lilypond-mode.el: Also "C-xC-s" sets default command to LilyPond.

2002-08-05  Rune Zedeler <rune@zedeler.dk>

	* mf/feta-eindelijk.mf: Fix silly typo in 16th and shorter rests.

2002-08-05  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* stepmake/bin/make-version.py: robustify.

	* input/test/rhythm-excercise.ly: new file

	* input/test/blank-notes.ly: new file

	* lily/note-head.cc (head_extent): robustness fix.
	
	* Documentation/user/preface.itely: add some more.

2002-08-04  Rune Zedeler <rune@zedeler.dk>

	* Documentation/user/refman.itely
	* Documentation/user/internals.itely: Documented "Current" property.
	
2002-08-04  Han-Wen  <hanwen@cs.uu.nl>

	* lily/lily-guile.cc: change gh_str02scm to scm_makfrom0str.

2002-08-04  Werner Lemberg  <wl@gnu.org>

	* tex/lilyponddefs.tex: s/filllastpage/lastpagefill/.
	
	* Documentation/user/refman.itely: Document it.

2002-08-04  Han-Wen  <hanwen@cs.uu.nl>

	* lily/main.cc (sane_putenv): Oops.  Should supply a private copy
	to putenv. (this was actually caught by valgrind, but I didn't
	think the error was mine... )

2002-08-03  Han-Wen  <hanwen@cs.uu.nl>

	* tex/lilyponddefs.tex: add filllastpage support.

	* GNUmakefile.in: barf if config.h is older than configure. 

	* VERSION: released 1.5.71 
	
	* lily/beam.cc (consider_auto_knees): rewrite function; now only
	consider horizontal knees. Fixes input/bugs/bizzarre-beam.ly

	* lily/syllable-group.cc (set_lyric_align): fix centering on note
	head for `normal' lyrics. This fixes input/bugs/lyrics-spacing.ly.

2002-08-02  Han-Wen  <hanwen@cs.uu.nl>

	* lily/beam.cc (connect_beams): fix quarter note beams.

	* input/regression/beam-quarter.ly: new file.

2002-08-02  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

	* buildscripts/mf-to-table.py (postfixes): Reduce the line spacing
	in the font list.

2002-08-02  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/scm-option.cc: excorcise iostream.

	* lily/main.cc: remove iostream usage.

2002-08-02  Han-Wen  <hanwen@cs.uu.nl>

	* scripts/lilypond-book.py: make URL for printfilename option.

	* lily/beam.cc (position_with_maximal_common_beams): fix kneed
	beamlets. This fixes input/bugs/knee

	* ly/engraver-init.ly (HaraKiriStaffContext): switch off auto knee
	for hara kiri staffs.

	* lily/slur-engraver.cc (try_music): remove nested slur
	functionality. This fixes spurious warnings with the partcombiner.

2002-08-01  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/parse-scm.cc (protected_ly_parse_scm): guile 1.4 compatibility.

2002-08-01 Rune Zedeler <rune@zedeler.dk>

	* lily/tab-note-heads-engraver.cc: add algorithm for automatically
	selecting frets when none given by user. Read property
	"minimumFret".

	* scm/translator-property-description.scm: Add "minimumFret"
	
	* mf/feta-eindelijk.mf: Changed layout of 16th and shorter rests
	to match the 8th rest. slanted 8th rest a bit more.
	WARNING: 8th rest and classical quarter rest exchanged.
	
2002-08-01  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

	* scm/grob-description.scm (RehearsalMark): Add baseline-skip to
	handle multiline marks correctly.

2002-07-31  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

	* scripts/ly2dvi.py (ly_paper_to_latexpaper): Fix dvips flags

2002-07-31 Rune Zedeler <rune@zedeler.dk>

	* input/SondagMorgen/*.ly: Added. TODO: Lots of cleanups but now
	it's there.

2002-07-31  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/parser.yy (chord_notes): typo. 

	* scm/music-functions.scm (unfold-repeats): bugfix

2002-07-31  Rune Zedeler <rune@zedeler.dk>

	* ly/engraver-init.ly: remove alias "Current" from all contexts.

	* lily/translator-group (find_existing_translator): If
	n=="Current", return this context.
	
	* lily/rest.cc:
	* lily/time-signature.cc: spacing for even number of staff lines.
	
2002-07-31  Han-Wen  <hanwen@cs.uu.nl>

	* input/bugs/: remove various files.

	* Documentation/user/refman.itely: doco updates.

	* scripts/ly2dvi.py (find_pfa_fonts): add and document --pdf
	option.

2002-07-30  Rune Zedeler <rune@zedeler.dk>

	* ly/engraver-init.ly: add alias "Current" to all contexts.

	* ly/property-init.ly: Use "Current" context in the accidental
	macros. TODO: Do the same in some of the other macros?
	
	* scm/output-lib.scm (tablature-stem-attachment-function): add
	duration argument. Now the function can be called again :-)

2002-07-30  Han-Wen  <hanwen@cs.uu.nl>

	* lily/parse-scm.cc (parse_handler): add better error message,
	return a sensible number of nchars

2002-07-29  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/parse-scm.cc (protected_ly_parse_scm): catch GUILE errors
	when parsing, and emit useful warning message.

	* lily/lily-guile.cc (ly_parse_scm): add line/col/file locations
	to SCM port for parser.

2002-07-28  Rune Zedeler <rune@zedeler.dk>
	
	* lily/note-spacing.cc (stem_dir_correction) Add property
	knee_spacing_correction controlling the amount of optical spacing
	added to knees.
	
2002-07-28  Glen Prideaux  <gprideau@odyssey.apana.org.au>
       
       * lily/syllable-group.cc (set_lyric_align): Only fiddle with
       alignment if a note has more than a single lyric so single stanza
       songs are aligned correctly.

2002-07-28  Han-Wen  <hanwen@cs.uu.nl>

	* input/test/broken-spanner-adjustment.ly: new file.

2002-07-27  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

	* scripts/lilypond-book.py: Handle printfilename also together
	with {small,}verbatim

2002-07-27  Juergen Reuter  <reuter@ipd.uka.de>

	* scm/output-lib.scm, lily/note-head.cc: fixed broken baroque
	note-head style by setting grob property font-family
	automatically.

2002-07-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	* VERSION: 1.5.70 released.
	
	* Documentation/user/lilypond-book.itely (Insert music snippets
	into your texts using lilypond-book): Briefly mention HTML
	documents.  Started rewrite, but lost inspiration.

	* lily/grob-scheme.cc (get_original, get_system, get_broken_into):
	Move scheme funcs from grob.cc and spanner.cc.

	* lily, flower: Ran buildscripts/ontgaar.py.  See also
	http://lilypond.org/wiki/?CodingStandards.
	
	* Documentation/GNUmakefile: Remove regression-test stuff.
	(deep-WWW-clean): Remove wiki-dump.  Fixes web-clean target.

	* Documentation/regression-test.tely: Remove.

	* Documentation/user/refman.itely (Text scripts): Comment out ref
	to PostScript output.

	* lily/beam.cc (knee_b): Fix to also work if some dirs are not
	set.

	* lily/beam.cc (set_stem_directions): For knees, set stems to
	their natural direction.

2002-07-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/stem.cc (calc_stem_info): Don't force stems of kneed beams
	to reach middle staff line.

	* lily/beam.cc (consider_auto_knees): Recalculate beam position
	after deciding for a knee.

2002-07-26  Han-Wen  <hanwen@cs.uu.nl>

	* Documentation/user/internals.itely: move output-formats doco to
	WikiWiki.
	
2002-07-25  Han-Wen  <hanwen@cs.uu.nl>
	
	* po/fr.po: update from TP

	* input/template/GNUmakefile (TITLE): add lysdoc target for the
	templates

	* Documentation/user/introduction.itely (Introduction): finish
	introduction 

2002-07-25  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/include/music-iterator.hh (class Music_iterator): change
	get_music() to get_pending_events().

2002-07-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	* buildscripts/ontgaar.py: get_music () -> get_pending_events ().
	
	* buildscripts/ontgaar.py: New file.

	* scm/grob-property-description.scm (conditional-elements): Add
	extent-X.

	* lily/grob.cc: Add extent-X and extent-Y to interface.

	* lily/grob-scheme.cc (ly_get_parent): Don't dereference null
	parent. (Han-Wen)

	* input/test/move-accidentals.ly: New file. (Han-Wen)

2002-07-25  Han-Wen  <hanwen@cs.uu.nl>

	* lily/grob-scheme.cc (ly_get_parent): don't crash if no parent.

	* lily/slur.cc (get_first_notecolumn_y): robustness: don't crash
	if no note-columns.

	* server.el.patch: new file.

	* Documentation/user/refman.itely (Point and click):  updates.
	(Graphical interfaces): add node
	(Vertical spacing): add node

2002-07-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily, lily/include: Rename line to system.  Junk _l suffix.

2002-07-24  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* po/fr.po: update from TP.

	* buildscripts/lilypond-profile.sh: update support for
	LILYPONDPREFIX

2002-07-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/user/refman.itely (Point and click): Add info
	about GVim, NEdit.

2002-07-24  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/accidental-placement.cc (extent_callback): remove function
	(position_accidentals): do nothing if not live.
	Use accidental-grobs property i.s.o. accidentals, to maintain
	proper typing. 

2002-07-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	* input/mutopia/J.S.Bach/baerenreiter-sarabande.ly: *
	input/test/count-systems.ly: Update to new system-count function
	names.

	* lily/grob.cc (get_line, get_original): Use LY_DEFINE.

	* lily/spanner.cc (get_broken_into): Use LY_DEFINE.

	* lily/include/spanner.hh:
	* lily/include/grob.hh: Remove DECLARE_SCHEME_CALLBACKs.

	* input/mutopia/J.S.Bach/baerenreiter-sarabande.ly: Add
	forcedBreak options and fix measure count comments.

	* GNUmakefile.in: Junk intl.

	* config.make.in (prefix): Prepend $(DESTDIR) to allow install
	without overriding prefix.

	* aclocal.m4: Regenerate.
	
	* stepmake/aclocal.m4: Don't expand $prefix: fixes install with
	other $prefix.

	* cygwin/GNUmakefile: 
	* ly/GNUmakefile: 
	* python/GNUmakefile: 
	* make/GNUmakefile: 
	* mf/GNUmakefile: 
	* scm/GNUmakefile:
	* tex/GNUmakefile: use local_package_datadir iso datadir.

	* make/substitute.make (ATVARIABLES): Add local_lilypond_datadir.

	* aclocal.m4: Regenerate.
	
	* config.hh.in:
	* config.make.in:
	* stepmake/aclocal.m4: Cleanups and more conventional naming for
	datadir ($prefix/share), package_datadir ($prefix/$package), and
	local_package_datadir ($prefix/$package/$version).
	
	* make/lilypond-vars.make:
	* scripts/ly2dvi.py:
	* scripts/lilypond-book.py:
	* scripts/mup2ly.py:
	* scripts/midi2ly.py: use local_package_datadir iso datadir.
	
	* GNUmakefile.in: build_datadir without version.
	
	* lily/main.cc: Datadir cleanup.

	* lily/text-item.cc (lookup_text): 
	* lily/music-output-def.cc (print_smob): 
	* lily/mensural-ligature.cc (brew_molecule):
	* lily/beam-quanting.cc (score_slopes_dy, score_forbidden_quants):
	Fix warnings.
	
2002-07-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	* input/mutopia/J.S.Bach/baerenreiter-sarabande.ly: Warn when not
	using 6 systems, like the original.

	* input/test/count-systems.ly: New file.

	* lily/spanner.cc (get_broken_into):
	* lily/grob.cc (original_scm, line_scm): New function.

	* lily/include/grob.hh (ly_scm2grob_array): Moved from
	group-interface.hh and renamed.
	(ly_grob_array2scm): New function.

2002-07-23  Juergen Reuter  <reuter@ipd.uka.de>

	* lily/ambitus-engraver.cc: bugfix: create ambitus grob during
	process_music phase

2002-07-23  Han-Wen  <hanwen@cs.uu.nl>

	* lily/separation-item.cc (width): cache extent in extent-X

	* lily/spacing-spanner.cc (standard_breakable_column_spacing):
	only add extent for non-musical column.

	* lily/accidental-placement.cc (split_accidentals): new function
	(get_relevant_accidental_extent): new function

	* lily/staff-spacing.cc (next_note_correction): idem

	* lily/separating-group-spanner.cc (find_rods): use
	conditional_width().
	
	* scm/sketch.scm: fix roundfilledbox definition

	* lily/lily-guile.cc (robust_list_ref): be sensible with negative
	argument. This fixes too-long stems on half and quarter notes.

2002-07-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/index.texi: Add, fix, change some links and names,
	including dump of wiki wiki.

	* Documentation/GNUmakefile (local-WWW): Slurp wiki.

	* buildscripts/wiki-slurp.py: New file.  Accept multiple pattern.
	(unwiki): Replace local urls with <img src> too.

	* Documentation/GNUmakefile (wiki-dump): New target.

	* Documentation/header.html.in: Link to Documentation/index
	renamed to Index (was other...).

	* Documentation/regression-test.tely: Remove.

	* make/lysdoc-targets.make (local-WWW): Add default targets .ps.gz
	and .pdf.

2002-07-22  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.69 released
	
	* lily/accidental-placement.cc (position_accidentals): document
	two bugcases.

	* lily/skyline.cc (skyline_meshing_distance): bugfixes.

2002-07-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	* input/regression/abe.ly: 
	* input/test/transposing.ly: Remove mention of mudela.

	* scripts/lilypond-book.py (make_pixmap): Don't use quiet_system,
	ie, don't redirect PNG output to /dev/null.  Fixes lys-to-tely
	documents.

	* input/test/mark.ly: 
	* Documentation/user/refman.itely: Re-enable \mark #'() example.

	* lily/parser.yy: Revert to MARK scalar.

2002-07-21  Han-Wen  <hanwen@cs.uu.nl>

	* lily/accidental.cc (accurate_boxes): add function to represent
	flat with 2 boxes. Improves flat-flat accidental spacing. 

	* lily/accidental-placement.cc (stagger_apes): try to arrange accs
	in a C form, with the top accidental closet to the chord.

	* lily/stem.cc (get_default_stem_end_position): don't crash if
	lengths not set.
	(get_default_stem_end_position): idem for stem-shorten.

	* mf/feta-toevallig.mf: enlarge flat bbox.

	* input/regression/lyrics-extender.ly: new file.

	* lily/lyric-extender.cc (brew_molecule): don't add
	right-trim-amount if extender is broken.

	* scripts/ly2dvi.py (global_latex_preamble): bugfix (thanks Werner).

2002-07-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/index.texi: Add pointers to new regression and
	test documents.

	* Documentation/user/converters.itely:
	Documentation/user/invoking.itexi: Some small fixes for uniform
	usage example.

	* input/allfontsize.ly, size*.ly: New files, moved from
	input/regression.
	
	* input/font20.ly, font-body.ly: New files, moved from input/test.
	
	* input/font*.ly: New files, moved from input/test.

	* input/test/*.ly: Remove empty files, fix broken ones.

	* input/test/different-time-signatures.ly: Add FIXME marker;
	comment-out broken code.

	* Documentation/regression-test.tely: Comment-out, add
	obsolete-marker and url to regression-test-dir.

	* input/test/GNUmakefile: 
	* input/regression/GNUmakefile: Add rule for lys-to-tely.py.

	* input/regression/+.ly:
	* input/test/+.ly: New file.

	* input/test/cue-notes.ly: better example

	* Documentation/user/refman.itely (Font selection): font size doco

	* input/mutopia/F.Schubert/standchen.ly: note bugfix

	* lily/stem.cc: rewrite of scoring to give sane results on knee
	beams.

	* lily/beam.cc (set_stem_lengths): extend stems for gapped tremolo
	beams.
	(connect_beams): chop off beaming outside the beam. Fixes problem
	with tremolo beams.

	* lily/score-engraver.cc (initialize): error if feta20.afm

2002-07-19  Han-Wen  <hanwen@cs.uu.nl>

	* scm/engraver-documentation-lib.scm
	(document-property-operation): add properties to context
	documentation.

	* scm/documentation-lib.scm (pad-string-to): align info menus.

2002-07-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	* debian/GNUmakefile: Remove lilypond.links.
	
	* debian/: Debian patch (Anthony Fok).
	
	* debian/lilypond.links: Remove, as per Anthony's request.

	* aclocal.m4: Regenerate.
	
	* stepmake/aclocal.m4: Add --with-kpathsea-include,
	--with-kpathsea-lib options.

	* scripts/mup2ly.py: Cut-n-paste include missing lilylib.

	* stepmake/stepmake/compile-vars.make: 
	* stepmake/stepmake/executable-rules.make: 
	* stepmake/stepmake/python-module-rules.make:
	* stepmake/stepmake/shared-library-rules.make: Use ALL_LDFLAGS, to
	guard agains user override of LDFLAGS.

	* Documentation/user/refman.itely: Compile fix for \mark #'(music ...).

	* Documentation/user/internals.itely: Use ly-set-mus-property!.

	* cygwin/mknetrel: New file.

	* cygwin: New directory.  Moved Cygwin stuff from
	Documentation/windows.
	
	* Documentation/windows/fix-suffixes.sh:
	* buildscripts/walk.sh: Junk.

	* aclocal.m4: Regenerate.

	* buildscripts/walk.sh: Remove.

	* stepmake/stepmake/topdocs-targets.make: 
	* stepmake/stepmake/help2man-rules.make: 
	* stepmake/stepmake/generic-vars.make: 
	* stepmake/make/stepmake.make: 
	* Documentation/user/GNUmakefile: 
	* make/stepmake.make: 
	* make/lilypond-vars.make: 
	* GNUmakefile.in: 
	* stepmake/aclocal.m4: Remove builddir cruftyness.
	
	* stepmake/stepmake/c++-rules.make: Use ALL_CXXFLAGS, to guard
	agains user override of CXXFLAGS.
	
	* stepmake/stepmake/c++-vars.make (ALL_CXXFLAGS): Include CXXFLAGS.
	
	* stepmake/stepmake/c-rules.make: Use ALL_CFLAGS, to guard
	against user override of CFLAGS.
	
	* stepmake/stepmake/c-vars.make (ALL_CFLAGS): Include CFLAGS.

2002-07-17  Han-Wen  <hanwen@cs.uu.nl>

	* GNUmakefile.in: distribute lexer-gcc-3.1.sh  as well
	
	* lily/music.cc (LY_DEFINE): change ly-set-mus-property to
	ly-set-mus-property!

	* lily/grob.cc (LY_DEFINE): change ly-set-grob-property to ly-set-grob-property!

	* lily/parser.yy (Repeated_music): shift duration log for tremolo
	repeats, instead of klutzing around.

	* lily/chord-tremolo-engraver.cc (acknowledge_grob): set X parent
	of stem tremolo grobs.

	* scm/music-functions.scm (shift-duration-log): new function, add
	to duration log of all notes.

	* lily/duration.cc: add compression factor arguments to
	make-duration.
	compression-factor, dot-count, duration-log: add scheme functions.

	* lily/mark-engraver.cc (process_music): allow \mark to take a
	number as argument as well.

2002-07-16  Han-Wen  <hanwen@cs.uu.nl>

	* lily/rest.cc (after_line_breaking): only translate the whole
	rest if we have more than 1 staff line

2002-07-16  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION: release 1.5.68

	* scripts/lilypond-book.py: fixes by Tom Cato Amundsen.

2002-07-15  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/beam-quanting.cc (score_forbidden_quants): split beam
	quanting functionality.
	(quanting): argh. Forgot how linear interpolation works. Bugfix.

	* Documentation/index.texi (Top): add whole-big-page documentation.

	* lily/side-position-interface.cc (general_side_position):
	Subtract parent offset iso. adding it. (Huh? How could this have
	worked?)

	* lily/clef-engraver.cc (stop_translation_timestep): add staff to
	OctavateEight support.

	* scripts/lilypond-book.py: add smallverbatim option.

	* lily/beam.cc (quanting): bugfix. Behave sanely when no visible
	stems.

	* lily/accidental-placement.cc (position_accidentals): add padding
	property. Increase default setting to 0.2. 

2002-07-15  Han-Wen  <hanwen@cs.uu.nl>

	* lily/paper-column.cc (before_line_breaking): urg. bugfix.

	* lily/separating-line-group-engraver.cc (finalize): don't replace
	right-items, but add to list. This fixes a bug when a staff ends
	with cross-staff voice switching away.
 
2002-07-14  Han-Wen  <hanwen@cs.uu.nl>

	* input/mutopia/GNUmakefile: move mutopia/ to input/mutopia/

	* lily/beam.cc (quanting): add explicit support for cross-staff
	beaming: make slope penalty larger.

	* lily/beam.cc: use common refpoints throughout. This fixes many
	cross staff issues.
 
	* lily/paper-column.cc (before_line_breaking): bug fix.

	* lily/volta-engraver.cc (process_music): do something sensible if
	no staffs found. 

	* scripts/lilypond-book.py (make_pixmap): opps. Do png conversion
	only once. 

	* Documentation/user/refman.itely (Global layout): made section on
	global layout, added spacing documentation.

	* lily/staff-symbol.cc (brew_molecule): change ragged right for
	staff symbols. See comments.

2002-07-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/voice-devnull-engraver.cc (acknowledge_grob): Use proper
	spelling for always.  In solo a due mode, kill spanners when the
	other thread has solo.

	* lily/thread-devnull-engraver.cc (acknowledge_grob): In solo a
	due mode, kill everything when the other thread has solo.

	* lily/a2-engraver.cc (acknowledge_grob): In solo a due mode, do
	not set directions when we have solo.

	* lily/part-combine-music-iterator.cc (process): Set property
	"othersolo" if the other thread has solo.

2002-07-13  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.67 released.
	
	* lily/beam.cc (calc_stem_y): fix beams on quarter notes.

	* lily/stem-tremolo.cc (brew_molecule): add code for stem tremolos.

	* lily/auto-beam-engraver.cc (create_beam_p): remember Beam
	settings at the start of a potential auto beam.

	* lily/include/sequential-iterator.hh (class Sequential_iterator):
	bugfix: protect music list from GC.

	* Documentation/user/introduction.itely: misc fixes.

	* scripts/ly2dvi.py (run_latex): show latex error log. Ask for
	bugreport if lilypond is killed by a signal. 

	* input/regression/beam-funky.ly:  new file

	* lily/input-smob.cc (make_input): GUILE 1.7 compatibility fixes.

	* lily/beam.cc: complete rewrite of multiplicity. This fixes 16th
	knees code.
	(quanting): add french beaming support (property french-beaming)
	(stem_beams): removed.

2002-07-12  Mats Bengtsson  <matsb@s3.kth.se>

	* lily/beam.cc (after_line_breaking): Set correct stem lengths
	also when beam positions are set manually.
	(consider_auto_knees): Do not use automatic knees if the directions
	are set manually by the user.

2002-07-12  Han-Wen  <hanwen@cs.uu.nl>

	* input/regression/grace-auto-beam.ly: new file

	* input/regression/grace-unfold-repeat.ly: new file

	* lily/auto-beam-engraver.cc (test_moment): never start on grace moments.

	* lily/forbid-break-engraver.cc (start_translation_timestep): skip
	grace notes for break-forbidding. Breaks during grace notes are
	handled by Bar_engraver.	

	* lily/unfolded-repeat-iterator.cc: Reimplement
	Unfolded_repeat_iterator, Volta_repeat_iterator using
	Sequential_iterator. All grace functionality from {} carries over
	to repeats as well.

	* lily/sequential-iterator.cc: new file: form baseclass for
	sequential music iterator and unfolded/volta repeat iterator.

2002-07-11  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/include/debug.hh: deprecate.

	* lily/spacing-spanner.cc (set_springs): add support for
	common-shortest-duration field.

	* lily/parser.yy (translator_spec_body): allow \set in \translator
	{}  block. This is the same as \override, here.

	* lily/score-engraver.cc (one_time_step): don't warn about columns
	when skipTypesetting == #t.

	* lily/spacing-spanner.cc (musical_column_spacing): change
	ragged right function to produce natural spacing.

2002-07-10  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/paper-column.cc (before_line_breaking): update
	#'bounded-by-me field for suicided items.  This fixes crazy
	spacing in \partcombine scores.

2002-07-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	* config.hh.in: Add HAVE_SSTREAM.
	
	* configure.in: Add check for sstream header.

2002-07-09  Mats Bengtsson  <matsb@s3.kth.se>
 
 	* flower/source-file.cc: Fix compatibility with older g++.
 
2002-07-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	* input/twinkle.ly: Bugfix: no automaticMelismata.

2002-07-08  Han-Wen  <hanwen@cs.uu.nl>

	* mutopia/J.S.Bach/Cembalo-Partitas/: remove

	* ly/engraver-init.ly (ScoreContext): turn on automaticMelismata
	by default.

	* lily/voice-devnull-engraver.cc (try_music):
	lily/thread-devnull-engraver.cc: use proper spelling for #'always.

	* lily/unfolded-repeat-iterator.cc (Unfolded_repeat_iterator):
	copy here_mom_ too. This fixes an obscure bug with combining
	partcombine and repeat

	* lily/chord-tremolo-iterator.cc (Chord_tremolo_iterator): copy
	factor too. 

2002-07-07  Han-Wen  <hanwen@cs.uu.nl>

	* mutopia/J.S.Bach/pa.ly: remove
	* mutopia/J.S.Bach/Duette/: remove  
	
	* scm/font.scm (change-rhs-size): add support for "paper19.ly"

	* VERSION: 1.5.66 released

	* scm/grob-description.scm (all-grob-descriptions): add
	item-interface where necessary

	* lily/score-engraver.cc (one_time_step): warn for grobs created
	during stop_translation_timestep().

	* lily/a2-engraver.cc: restrict acknowledged grob types.

	* lily/chord-name-engraver.cc: remove acknowledge_grob().

	* Documentation/user/tutorial.itely: doc carnage.

2002-07-06  Rune Zedeler  <rune@zedeler.dk>

	* Documentation/user/refman.itely: Documented accidentals
	(incl. bugs), subdivideBeams and drum/percussion notation.

	* lily/translator-group.cc, lily/include/translator-group.hh
	(Translator_group::set_children_property): removed.

	* lily/accidental-engraver.cc: don't use
	Translator_group::set_children_property.

	* lily/new-accidental-engraver.cc: Added. More correct
	accidentals, but wrong spacing.

	* lily/beam-enagraver.cc, lily/auto-beam-engraver.cc: Small
	subdivideBeams-fixes.

	* scm/drums.scm: Small changes/fixes in instruments and maps
	
2002-07-05  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lexer-gcc-3.1.sh: Fixes and more comments.

	* Documentation/topdocs/INSTALL.texi: Add comment about gcc-3.0.4
	problems.

	* lily/include/stream.hh:
	* lily/include/moment.hh:
	* lily/include/midi-stream.hh:
	* lily/streams.cc:
	* lily/scm-option.cc:
	* lily/parser.yy:
	* lily/my-lily-lexer.cc:
	* lily/moment.cc:
	* lily/midi-stream.cc:
	* lily/main.cc:
	* lily/lexer.ll:
	* lily/includable-lexer.cc:
	* flower/include/source-file.hh:
	* flower/include/parray.hh:
	* flower/include/dictionary.hh:
	* flower/include/array.icc:
	* flower/string.cc: 
	* flower/source-file.cc:
	* flower/getopt-long.cc: gcc-3.1 fixes.

	* stepmake/stepmake/generic-targets.make: Add comment about warning.

	* lexer-gcc-3.0.patch: Add comment, and a fix for installations
	that have an unpatched flex and gcc-3.1.x.

	* Documentation/topdocs/INSTALL.texi: Add comments and
	instructions on gcc-3.1.x.

	* lexer-gcc-3.1.sh: New file.

	* aclocal.m4: regenerate.
	
	* stepmake/aclocal.m4: Version compare fix.

2002-07-05  Han-Wen  <hanwen@cs.uu.nl>

	* ly/engraver-init.ly (RhythmicStaffContext): stems up by default.

	* lily-guile.hh: remove guile 1.3 compatibility,  add 1.4
	compatibility functions.

2002-07-05  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/windows/lilypond.hint (requires): Add libintl2.

2002-07-04  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION: 1.5.65 released. 
	
	* scripts/lilypond-book.py: patches by Tom Cato Amundsen.  Adds
	support for the columnsep when using the geometry package.
	
2002-07-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	* scm/grob-property-description.scm (minimum-space-pair): Remove.

	* Documentation/windows/README: 
	* Documentation/windows/guile-1.5.6-1.5.6.jcn2.patch:
	* Documentation/windows/changelog: New file.

	* Documentation/windows/lilypond.hint (requires): libguile14 (was:
	guile).

2002-07-03  Han-Wen  <hanwen@cs.uu.nl>

	* lily/grob-property.cc (HASHING_FOR_MUTABLE_PROPS): experiment:
	try hash tables for mutable properties.

	* lily/align-interface.cc: remove aligned-interface and props
	minimum-space-pair extra-space 

	* lily/grob-property.cc: new file move grob prop handling here.

	* lily/lily-guile.cc (ly_deep_copy): add vector support

	* lily/break-substitution.cc (do_break_substitution): add vector
	support.

	* lily/spanner.cc: remove extend_spanner_over_* funcs.

2002-07-02  Jan Nieuwenhuizen  <janneke@gnu.org>

	* stepmake/aclocal.m4 (STEPMAKE_GET_VERSION): Workaround for
	broken Debian gcc version string: 'gcc (GCC) 3.1.1 20020606
	(Debian prerelease)'

2002-07-02  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/bar-check-iterator.cc (process): change
	barbarCheckNoSynchronize to barCheckSynchronize

	* Documentation/user/bugs.itexi: move to introduction, remove.

	* Documentation/user/*.itexi: general carnage/cleanage.
	
	* Documentation/user/internals.itely: split most of file into
	internal documentation (.scm and .cc)

	* buildscripts/make-font-dir.py: put designsize in to X font
	sWidth field

	* make/lilypond.redhat.spec.in: postinstall bugfix

2002-07-02  Juergen Reuter  <reuter@ipd.uka.de>

	* lily/ambitus-engraver.cc, lily/ambitus.cc: Various bugfixes:
	avoid segfault on undefined ambitus pitch; avoid wasteful creation
	of pitch smobs; defer computation of centralCPosition beyond first
	timestep to catch also clefs outside of the current voice context.

2002-07-02  Han-Wen  <hanwen@cs.uu.nl>

	* input/template/satb.ly: new file

2002-07-01  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/user/glossary.tely: Precautions for lilypond-book:
	don't use spaces after @lilypond options.

	* Documentation/topdocs/INSTALL.texi (Top): Remove generic Guile
	threads warning.

2002-07-01  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION (MAJOR_VERSION): 1.5.64

2002-06-30  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/grob.cc (mark_smob): don't mark parents, explain why.

	* tex/lilyponddefs.tex: Define outputscale only once.

2002-06-29  Jan Nieuwenhuizen  <janneke@gnu.org>

	* configure.in: Require guile 1.4 or newer (was 1.3.4?).

2002-06-29  Han-Wen  <hanwen@cs.uu.nl>

	* lily/(phrasing-)slur-engraver.cc: remove slur{Begin|End}Attachment.

	* lily/separating-line-group-engraver.cc (acknowledge_grob):
	ignore grobs with no-spacing-rods set.

	* Documentation/user/tutorial.itely (Fine tuning a piece): more tut.

	* scm/grob-description.scm (all-grob-descriptions): sort list
	
2002-06-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/user/tutorial.itely (A piano excerpt): Bugfix:
	remove stray brace.

	* Documentation/topdocs/FAQ.texi (Installation): Add
	lilypond-devel list.  Add faq about font removal.  Fix faq about
	generating and running ./configure.

2002-06-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	* scm/chord-name.scm (chord::name->text): Workaround: clean markup
	text.

	* lily/text-item.cc (markup_text2molecule): Bugfix: raise only once.

	* input/test/ambitus.ly:
	* lily/ambitus-engraver.cc:
	* lily/ambitus.cc:
	* lily/include/ambitus.hh: New file.

	* GNUmakefile.in (local-clean): Also remove builddir-setup's symlinks.

2002-06-25  Juergen Reuter  <reuter@ipd.uka.de>

	* input/test/ambitus.ly, lily/ambitus-engraver.cc,
	lily/ambitus.cc, lily/include/ambitus.hh, ly/engraver-init.ly,
	scm/basic-properties.scm, scm/grob-description.scm,
	scm/grob-property-description.scm: Add support for ambitus.

2002-06-24  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/text-spanner.cc: add some props to interface (patch
	courtesy Chris J).

2002-06-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/text-spanner.cc (setup_pedal_bracket): Bugfix: only
	dereference valid Grob.

	* configure.in: Quoting fixes.

2002-06-24  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.63 released

	* lily/grob-scheme.cc: new file

	* lily/break-substitution.cc: split up break substitution
	functionality, and make a special constant stack-space version for
	lists of grobs. This should fix the problems of lily in
	combination with pthreads/qthreads.

	* lily/grob.cc (mark_smob): bugfix: mark other parent too.

2002-06-23  Chris Jackson  <chris@fluffhouse.org.uk>

	* lily/text-spanner.cc (setup_pedal_bracket):
	* lily/piano-pedal-engraver.cc (create_bracket_grobs): 
	Fix the lengths of mixed-style piano pedal brackets.

2002-06-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/user/tutorial.itely (First steps): Add missing
	quotation.

	* Documentation/topdocs/INSTALL.texi (Top): Add some warnings
	about guile --with-threads.  Hopefully this issue can be resolved
	rsn, but maybe we should even add warnings for the standard Debian
	and Red Hat packages?

	* configure.in: Warn if guile is configured to use threads.  Maybe
	we should make this an error (ie, add to REQUIRED list?)

	* config.make.in (PACKAGE_NAME):
	(PACKAGE, package):  Don't hardcode.

	* VERSION (PACKAGE_NAME): Typo fix.

2002-06-23  Han-Wen  <hanwen@cs.uu.nl>

	* input/tutorial/brahms-*.ly: new tutorial files.

	* Documentation/user/tutorial.itely: fixes. Extend cheat sheet.

	* scm/script.scm (default-script-alist): fermata is up.

	* lily/dynamic-engraver.cc (stop_translation_timestep): stop
	dynamic line spanner when there is no crescendo to connect.

	* lily/tie.cc (get_control_points): add test to avoid flat ties.

2002-06-22  Han-Wen  <hanwen@cs.uu.nl>

	* lily/note-collision.cc (check_meshing_chords): don't crash if no
	stems.

	* scm/music-functions.scm (toplevel-music-functions): new
	definition. Functions to apply automatically. Removes the need for
	explicitly doing \apply #voicify-music

	* lily/grob.cc (do_break_substitution): rename function, use
	global var for criterion argument. Reduces stack usage a little.

	* ly/engraver-init.ly (StaffContext): add Instrument_engraver

	* scripts/convert-ly.py, lily/*.cc, scm/*.scm: change
	visibility-lambda to break-visibility

2002-06-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	* input/bugs/part-combiner.ly: New file.

	* lily/include/spacing-interface.hh: New file.

	* lily/include/spaceable-element.hh: Remove.

	* input/test/script-priority.ly: New file.

2002-06-20  Han-Wen  <hanwen@cs.uu.nl>

	* lily/system.cc (output_lines): kill grobs that are only for spacing.

2002-06-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/fingering-engraver.cc (make_script): 
	* lily/script-engraver.cc (process_music): 
	* lily/text-engraver.cc: 
	(process_acknowledged_grobs): Remove hard coded script-priority.

	* flower/warn.cc: Cleanup.

	* lily/voice-devnull-engraver.cc: Also eat multi-measure rest, a
	spanner now.

	* aclocal.m4: Regenerate.

	* stepmake/aclocal.m4: Also set GUILE_PATCH_LEVEL.

	* config.hh.in: Only set GUILE_MAJOR_VERSION if necessary.
	* lily/include/lily-guile.hh: Only include config.h if necessary.

	* Changelog: cvs changes ml archive test #8.
	
	* lily/slur-engraver.cc: Layout fix.

2002-06-19  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* ly/engraver-init.ly (RhythmicStaffContext): add
	Dot_column_engraver, resurrect barlines 
	
	* VERSION: 1.5.62 released.

	* lily/engraver-group-engraver.cc (do_announces): rename
	create_grobs () to process_acknowledged_grobs().

	* lily/grob.cc (programming_error): add programming_error with
	origin location.  

	* lily/tuplet-bracket.cc (parallel_beam): robustness check, don't
	fail if a beam doesn't have stems.  

	* lily/engraver-group-engraver.cc (do_announces): scary change in
	calling convention of create_grobs():  no create_grobs() call
	before acknowledge_grobs().

	* lily/sequential-music-iterator.cc (skip): add support for grace
	notes. 

	* lily/music.cc (Music): fix very subtle and nasty memory
	corruption bug. Typical symptom: "programming_error: Rhythmic_req
	has no duration"

	* mutopia/claop.py: new file: CLA(O)P II by Peter Wallin.

2002-06-19  Han-Wen  <hanwen@cs.uu.nl>

	* ly/engraver-init.ly (RhythmicStaffContext): add
	Dot_column_engraver
	

	* lily/parser.yy: various protection fixes. Less objects are now
	overprotected.

2002-06-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	* stepmake/bin/release.py (prev_ver): Bugfix: assume new diff
	naming scheme.

	* Documentation/windows/zlily-profile.sh:
	* Documentation/windows/post-lilypond.sh: Assume normal
	prefix=/usr for lilypond.

	* lily/musical-request.cc (length_mom): Display origin with error.

	* input/test/duration-check.ly: New file.

	* lily/lily-guile.cc (ly_pair_p): [PARANOID]: Check for freed
	cells.

	* lily/part-combine-music-iterator.cc (get_state): Bugfix: use
	ly_symbol2scm to get a scm symbol (rather than ly_str02scm).

	* aclocal.m4:
	* autogen.sh: Regenerate.
	
	* Documentation/topdocs/INSTALL.texi: 
	* configure.in: 
	* stepmake/configure.in:
	* stepmake/aclocal.m4: Revert autoconf upgrade.  Autoconf 2.53 has
	a serious bug wrt AC_CONFIG_AUX_DIR (reported).  Creating
	./configure once again requires autoconf == 2.13.

	* stepmake/autogen.sh: Check for autoconf == 2.13.

2002-06-18  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/parser.yy (open_request_parens): add input locations to
	open and close parens. 

2002-06-17  Chris Jackson <chris@fluffhouse.org.uk>

	* lily/tuplet-bracket.cc:
	* lily/text-spanner.cc: 
	* lily/piano-pedal-engraver.cc: 
	* scm/grob-description.scm: 
	* scm/grob-property-description.scm: Changed the
	edge-width property of brackets to edge-widen. Changed the sign of
	the left element of edge-widen so a pair of equal numbers produces
	a symmetrical bracket.

2002-06-17  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* ly/espanol.ly: added.

	* lily/simple-spacer.cc (solve): remove assert.

2002-06-17  Han-Wen  <hanwen@cs.uu.nl>

	* lily/forbid-break-engraver.cc (class
	Forbid_line_break_engraver): new engraver: forbid linebreaks
	during playing notes

	* lily/spacing-spanner.cc (loose_column): add another check: don't
	move around bar lines as loose columns.

	* scm/basic-properties.scm (default-break-barline):  add pre-break
	for .| barline

2002-06-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	* GNUmakefile.in (builddir-setup): Bugfix: include srcdir/tex as
	well as mf/out as subdirs of tex, for kpathsea to find through TEXMF.

	* scripts/lilypond-book.py (environment): Bugfix: update to new
	TEXMF scheme, from ly2dvi.

	* lily/lookup.cc (slur): Invoke bezier-bow.

	* scm/tex.scm (bezier-bow): 
	* scm/ps.scm (bezier-bow): Bezier sandwich with rounded endings
	(Previously named bezier-sandwich).
	
	* scm/tex.scm (bezier-sandwich):
	* scm/ps.scm (bezier-sandwich): Plain bezier sandwich.

	* make/lilypond.mandrake.spec.in (post): 
	* make/lilypond.suse.spec.in (post): 
	* make/lilypond.redhat.spec.in (post): Also remove parmesan fonts.
	
	* tex/lilyponddefs.tex: Uncomment feta character support.

	* Documentation/user/refman.itely (Pitches): Add espanol.ly
	description.

	* ly/catalan.ly: Add comment about (spanish) -s suffix.

	* ly/espanol.ly: Spanish note names by Carlos Garc'ia Su'arez
	<cgscqmp@terra.es>.

2002-06-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	* GNUmakefile.in (short-examples):
	(long-examples): Bugfix for --srcdir build.
	(top-web): Rewrite weblist find command.

	* stepmake/bin/config.sub: 
	* stepmake/bin/config.guess: Update from latest autotools.

	* aclocal.m4:
	* autogen.sh: Regenerate.
	
	* configure.in: 
	* stepmake/configure.in: 
	* stepmake/aclocal.m4: Run autoupdate.  Creating ./configure now
	requires autoconf >= 2.50.

	* stepmake/autogen.sh: Check for autoconf >= 2.50.

	* Documentation/user/refman.itely: Bugfix for tablature example.

	* Documentation/windows/compiling.texi: Update for new and
	improved setup.

2002-06-14  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/spacing-spanner.cc (find_shortest): make 1/8 configurable:
	introduce base-shortest-duration

	* lily/parser.yy (music_output_def_body): don't crash when \tempo
	in unexpected \midi{} is found.

2002-06-13  Jan Nieuwenhuizen  <janneke@gnu.org>

	* stepmake/GNUmakefile.in: Don't install stepmake.  This breaks
	the use of make/ly.make for use as an external makefile.  Probably
	noone except for myself ever used this anyway.

	* stepmake/stepmake/GNUmakefile (INSTALLATION_DIR): Bugfix: Adapt
	to new $datadir convention (<package>/<version>).

2002-06-13  Han-Wen  <hanwen@cs.uu.nl>
	
	* VERSION: 1.5.61 released
	
	* Document/user/refman.itely: tablature doc and code updates by
	Jean-Baptiste Lamy <jiba@tuxfamily.org>
	
	* input/template/piano-dynamics.ly: bugfixes.

	* lily/key-engraver.cc (try_music): read request only once. Don't
	overwrite lastKeySignature. Call create_key() only once. This
	fixes a bug with multiple equal key changes on polyphonic staffs.

2002-06-12  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

	* scm/grob-description.scm: Add side-position-interface to TextSpanner

	* scm/grob-property-description.scm: Document the trill line type.

2002-06-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	* stepmake/stepmake/generic-vars.make: 
	* make/lilypond-vars.make:
	* GNUmakefile.in (builddir-setup): New setup for builddir run.
	Fixes LilyPond run from builddir for --srcdir builds.

	* Documentation/windows/GNUmakefile (OUT_PROFILES): Bugfix for
	--srcdir build.

2002-06-12  Han-Wen  <hanwen@cs.uu.nl>

	* scm/grob-description.scm (all-grob-descriptions): add
	font-family to RehearsalMark

	* scm/drums.scm: move over definitions from drum-pitch-init.ly

	* lily/volta-bracket.cc (brew_molecule): bugfix, don't do anything
	if glyph not set.

2002-06-12  Heikki Junes  <heikki.junes@hut.fi>

	* lilypond-mode.el: Propose saving before applying a command:
	for saved buffer set default command to LilyPond.

2002-06-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	* buildscripts/mutopia-index.py (headertext_nopics): Add missing
	variable.

	* Documentation/windows/lilypond.hint: Renamed (previously setup.hint).

	* Documentation/windows/lilypond-doc.hint: New file.

	* GNUmakefile.in: Forward port: Add toplevel target install-html-doc.
	Bugfixes for --srcdir html-doc build.
	
	* make/lilypond-vars.make (LILYPOND_BOOK_INCLUDES): Forward port:
	Bugfix: Include $(builddir)/mf/out (was $(srcdir)/mf/out.

2002-06-10  Han-Wen  <hanwen@cs.uu.nl>

	* ly/script-init.ly (pralldown): add some scripts.

	* Documentation/user/refman.itely: many edits.

2002-06-09  Han-Wen  <hanwen@cs.uu.nl>

	* lily/tuplet-bracket.cc (brew_molecule): don't translate in Y
	direction, this breaks staffline avoidance of the bracket when
	they're horizontal.

2002-06-08  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

	* scripts/midi2ly.py: Fix handling of -o

2002-06-08  Han-Wen  <hanwen@cs.uu.nl>

	* lily/molecule.cc (translate): set max distance to 100 cm.

2002-06-07  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION: 1.5.60 released

	* lily/beam.cc: tremolo fix.

	* scripts/convert-ly.py:  add tuplet-X-visibility rules.
	add VerticalExtent -> verticalExtent rules.

	* lily/axis-group-engraver.cc: consistent case for
	XxxxVerticalExtent properties.  

	* Documentation/user/refman.itely (Tuplets): update
	tuplet-X-visibility properties. 

	* input/test/defaultbars.ly: Corrected (thanks Mats)
	
2002-06-05  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/beam.cc (shift_region_to_valid): fix stupido bug. 

	* buildscripts/lilypond-profile.sh: override settings if
	LILYPONDPREFIX is set.

2002-06-04  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

	* scripts/ly2dvi.py (non_path_environment): Fix typo

2002-06-03  Heikki Junes  <heikki.junes@hut.fi>

	* lilypond-mode.el: Extend "Quick notes" containing note tuples.

	* lilypond-font-lock.el: Add fixes and comments to syntax-table.

2002-06-03  Han-Wen  <hanwen@cs.uu.nl>

	* lily/beam-engraver.cc (class Grace_beam_engraver): derive from
	beam-engraver: use different engraver so we can mix normal and
	grace beams.

2002-06-01  Han-Wen  <hanwen@cs.uu.nl>

	* lily/beam.cc (shift_region_to_valid): Try to shift positions
	after slope-damping and concaveness check, so that short-stems are
	not violated.

2002-05-31  Jan Nieuwenhuizen  <janneke@gnu.org>

	* stepmake/aclocal.m4: Fix for ash as /bin/sh.

2002-05-31  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.59 released 
	
	* scripts/musedata2ly.py (Parser.parse_note_line): add dots. Add
	notice that missing features are exercise for user.

2002-05-30  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/beam.cc (score_stem_lengths): Bugfix for knees: use correct
	(but alas, not partly precomputed) value for current_y when
	calculating stem length demerits.
	(calc_stem_y): Temporary precomputed factors fix.

	* lily/stem.cc (calc_stem_info): Take multiplicity into account
	for shortest_y too.

	* input/bugs/melisma-tie-rest.ly: New file.

2002-05-30  Han-Wen  <hanwen@cs.uu.nl>

	* lily/stem.cc (calc_stem_info): remove min_y member, rename
	stuff. 	Remove kneeing stuff.

	* lily/beam.cc (brew_molecule): remove beam direction. Lots of
	twiddling

2002-05-29  Jan Nieuwenhuizen  <janneke@gnu.org>

	* scm/sketch.scm: 
	* scm/ps.scm: 
	* scm/pdftex.scm: 
	* scm/pdf.scm: 
	* scm/tex.scm: Add check for Guile-1.4.1.  Guile includes
	patch-level of version in minor-version string.  Arg.

2002-05-29  Han-Wen  <hanwen@cs.uu.nl>

	* ly/engraver-init.ly (TabStaffContext): 
	enable TabStaff by default.

	*  Tablature support by Jean-Baptiste Lamy <jiba@tuxfamily.org>

2002-05-28  Jan Nieuwenhuizen  <janneke@gnu.org>

	* config.hh.in: Remove duplicate DIR_DATADIR entry.

	* aclocal.m4: Regenerate.
	
	* stepmake/aclocal.m4: Append $FULL_VERSION to datadir.

2002-05-25  Heikki Junes  <heikki.junes@hut.fi>

	* lilypond-mode.el: Added Deutsch notes and fixed "Quick notes".

	* lilypond-mode.el: Write notes with fewer keystrokes trough a 
	"Quick notes"-interface.

2002-05-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	* input/regression/non-empty-text.ly: Update example with outdated
	comment.

2002-05-25  Han-Wen  <hanwen@cs.uu.nl>

	* scripts/convert-ly.py:  add textNonEmpty rule

	* lily/text-engraver.cc (create_grobs): remove textNonEmpty

2002-05-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/text-item.cc (markup_text2molecule): Junk ugly lookahead by
	using translate-robust add_molecule instead of add_at_edge.
	Bugfix for #(lines (finger "" "1")).

2002-05-24  Han-Wen  <hanwen@cs.uu.nl>

	* lily/stem-tremolo.cc (brew_molecule): clean up and fix stem
	tremolo placement.

2002-05-22  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.58
 	
	* Documentation/user/refman.itely: Bugfix: add node Repeats and
	MIDI.  Regenerate menu.  Fix @end example.

	* lily/accidental.cc: Add cautionary-style to interface.

	* mf/feta-beugel.mf (code): use autometric macros for braces.
	This fixes input/bugs/braces.

	* lily/afm.cc (count): return numOfChars, not size of array
	(always equals 256.)

	* lily/script.cc (before_line_breaking): postpone setting the
	X-parent of vertical scripts. This fixes the case of scripts on
	chords with seconds 

2002-05-21  Han-Wen  <hanwen@cs.uu.nl>

	* scm/grob-description.scm:  fix alignment of barnumber: make sure
	it doesn't hit the G-clef. 

	* input/mozart-hrn3-defs.ly (startGraceMusic): typo (it's
	startGraceMusic not startGraceContext).

2002-05-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	* stepmake/autogen.sh: Check for autoconf2.13, and abort if not
	found.

2002-05-20  Han-Wen  <hanwen@cs.uu.nl>

	* lily/accidental-engraver.cc: remove old accidental engraver,
	move new one to accidental-engraver.cc.

	* lily/local-key-item.cc: remove file

	* lily/include/local-key-item.hh: remove file

	* scripts/ly2dvi.py (make_preview): add --preview-resolution
	option.

	* lily/accidental.cc (brew_molecule): support for cautionary
	accidentals. 

	* lily/note-head.cc (internal_brew_molecule): warn if note head
	not found.

	* lily/time-signature.cc (special_time_signature): remove warning
	about time signature. 

	* lily/spacing-spanner.cc (musical_column_spacing): Prevent
	reverse springs by limiting fixed-note space.

2002-05-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	* stepmake/aclocal.m4: Bugfix: complain if program not found.

	* scripts/update-lily.py (next_version, prev_version, diff_name):
	New function.  Patches now named name-prev-latest.diff.gz.
	Bugfix: import shutil.

2002-05-19  Han-Wen  <hanwen@cs.uu.nl>

	* input/tutorial/sammartini.ly: fix and document autochange
	weirdness.

	* scm/pdftex.scm: resurrect PDFTeX output. Still doesn't work, but
	does produce .pdftex files.

	* lily/note-collision.cc (check_meshing_chords): move file from
	collision.cc, implement merged note heads (there you go, Drarn :-)

	* input/regression/collision-heads.ly: new file

	* VERSION: 1.5.57 released.

2002-05-18  Juergen Reuter  <reuter@ipd.uka.de>

	* mf/parmesan-heads.mf, scm/grob-description.scm,
	scm/grob-property-description.scm, scm/interface-description,
	lily/include/my-lily-parser.hh, lily/include/ligature-head.hh,
	lily/include/mensural-ligature.hh, lily/include/lily-proto.hh,
	lily/include/ligature-engraver.hh,
	lily/include/ligature-bracket.hh, lily/parser.yy,
	lily/ligature-bracket-engraver.cc, lily/mensural-ligature.cc,
	lily/mensural-ligature-engraver.cc, lily/note-heads-engraver.cc,
	lily/ligature-head.cc, lily/ligature-engraver.cc,
	lily/ligature-bracket.cc, input/test/mensural-ligatures.ly:
	implemented white mensural ligatures (still with a big list of
	TODOs)


2002-05-19  Han-Wen  <hanwen@cs.uu.nl>

	* lily/*.cc: use LY_DEFINE everywhere. Move doc strings from
	Documentation/user/internals.itely.

	* lily/function-documentation.cc: new file. Infrastructure for
	self documenting Scheme functions.

2002-05-18  Han-Wen  <hanwen@cs.uu.nl>

	* lily/stem.cc (calc_stem_info): bugfix for less ugly knees.

2002-05-17  Han-Wen  <hanwen@cs.uu.nl>

	* scripts/lilypond-book.py (re_dict): fix regexps; don't combine ?
	and * (as in "([^>]*)?")

2002-05-17  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/topdocs/INSTALL.texi: Update GCC, Flex and GUILE info.
	Add info about CVS.  Stable/development are currently 1.4/1.5,
	both at lilypond.org.

	* autogen.sh: Generate.

	* stepmake/configure:
	* configure: Regenerate.
	
	* stepmake/stepmake/automatically-generated.sub.make: Keep
	original first line.

	* stepmake/stepmake/toplevel-targets.make (autogen.sh): Add rule.

	* stepmake/stepmake/generic-targets.make (configure): Generate
	using autogen.sh.

	* GNUmakefile.in (SCRIPTS):
	* stepmake/GNUmakefile.in (SCRIPTS): Add autogen.sh

	* stepmake/autogen.sh: New file.

	* configure: Check for g++ >= 2.95.

	* stepmake/aclocal.m4: Fixes for FlexLexer.h, Python headers.  GNU
	c/c++ version checking.

	* flower/include/string.hh: Typo fix.

	* lily/include/midi-item.hh: Remove stray i.

	* Documentation/windows/GNUmakefile: Avoid collapsed directory
	constructs '//'.
	
	* stepmake/bin/install-dot-exe.sh: Filter collapsed directory
	constructs '//' from arguments.

2002-05-17  Han-Wen  <hanwen@cs.uu.nl>

	* scm/lily.scm (ly-load): show SCM filenames if verbose.

	* lily/lily-guile.cc (init_functions): add ly-verbose function.

	* lily/main.cc (setup_paths): remove LILYINCLUDE support. 

	* flower/include/{pointer,tuple}*: removed.

	* VERSION: released 1.5.56
	
	* scm/music-functions.scm (check-start-chords): function to check
	for chords without \context. Apply automatically from parser.

2002-05-16  Han-Wen  <hanwen@cs.uu.nl>

	* lily/bar-line.cc: remove index entries. Texinfo can't handle  :
	in index entries.

	* scm/output-lib.scm: fix ez notation stems. 

	* lily/paper-outputter.cc: various fixes to speed up compilation.

2002-05-16  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

	* scripts/lilypond-book.py: Don't import pre for Python >= 2.2

2002-05-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	* scripts/lilypond-book.py (determine_format): Bugfix: correctly
	determine latex input.

	* stepmake/bin/install-sh: Include latest from libtool.

	* stepmake/configure: 
	* configure: Regenerate.

	* config.make.in: Remove dead variables.  Add OPTIONAL/REQUIRED lists.
	(USER_CFLAGS): Bugfix, include CPPFLAGS.

	* configure.in: Use new OPTIONAL/REQUIRED mechanism.

	* stepmake/aclocal.m4: Add mechanism for checking OPTIONAL or
	REQUIRED programs and version.  Try to continue configuring, list
	missing programs at the end, but don't generate a GNUmakefile if
	REQUIRED programs are missing.  Cleanups, junk obsolete stuff.
	Fix Cygwin detection, drop '32' suffix.  Hoping this is not too
	fancy for some older systems.

2002-05-16  Han-Wen  <hanwen@cs.uu.nl>

	* lily/score-engraver.cc (typeset_all): sanity check for items
	that are Y parent to spanner. 

	* lily/piano-pedal-engraver.cc (create_bracket_grobs): fix broken
	pedal spanners.

2002-05-15  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/*.cc: remove as many iostream use as possible. 

	* flower/ : remove text-db, text-stream, data-file.
	
2002-05-15  Han-Wen  <hanwen@cs.uu.nl>

	* scripts/lilypond-book.py: add --no-music option: strip all blocks.
	(completize_preamble): don't barf if no preamble present.
	(do_file): allow extensions on --output

	* scripts/ly2dvi.py (make_preview): make automatic preview of
	first system. Small cleanups.

2002-05-13  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* scripts/lilypond-book.py (make_pixmap): output png directly.

	* mf/GNUmakefile (INSTALLATION_OUT_FILES4): create and install
	fonts.dir file.

	* lily/parser.yy (My_lily_parser): comment out code. (Causes
	problems  with recent bison releases).

	* make/lilypond.redhat.spec.in: add pfa fonts to X. 

2002-05-07  Heikki Junes <hjunes@cc.hut.fi>

	* lilypond-font-lock.el: Fixes the order of the note name list.

2002-05-06  Jan Nieuwenhuizen  <janneke@gnu.org>

	* scripts/lilypond-book.py: Add html/dtml output, pseudo-filter
	capability, --verbose option, rlimit hack.

2002-05-05  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/piano-pedal-engraver.cc: cleanups.

	* lily/accidental.cc (after_line_breaking): add break tie
	reminders.

	* lily/text-engraver.cc (try_music): don't typeset fingerings

2002-05-05  Heikki Junes <hjunes@cc.hut.fi>

	* lilypond-font-lock.el: Handle \breve as a note (rest) duration.

2002-05-04  Han-Wen  <hanwen@cs.uu.nl>

	* lily/*.cc: change gh_str02scm() to ly_str02scm().

	* lily/spacing-spanner.cc (note_spacing): Bound
	shortest-playing-length by the distance to next note. This should
	fix chord tremolo spacing.

	* VERSION: 1.5.55 released

	* lily/stem.cc (off_callback): invisible stem over whole note is
	centered on note now.

	* lily/stem-engraver.cc (acknowledge_grob): X_AXIS Parent of
	stem-tremolo is stem now.

	* input/mozart-hrn*.ly: many corrections. 

	* lily/dynamic-engraver.cc (acknowledge_grob): add Scripts  to
	support for dynamic scripts.

	* lily/accidental-placement.cc (position_accidentals): check for
	collisions as well: should avoid those heads too.

	* lily/beam.cc (check_concave): allow undefined gap and
	threshold. Change the meaning of threshold/gap == 0.0.
	(check_concave): skip Stolba concaveness check if we have a knee
	on outer stems.

2002-05-03  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

	* lily/chord-tremolo-engraver.cc (try_music): Handle chord
	tremolos of dotted duration.

2002-05-03  Han-Wen  <hanwen@cs.uu.nl>

	* mf/feta-klef.mf: more twiddling with G clef. Almost straight
	downstroke again. Sigh.

	* lily/dynamic-engraver.cc (acknowledge_grob): center dynamic
	script on note head.

2002-05-02  Han-Wen  <hanwen@cs.uu.nl>

	* lily/slur.cc (add_column): allow slur over rest. 

2002-04-27  Han-Wen  <hanwen@cs.uu.nl>

	* lily/beam.cc: move scoring constants out of code

2002-04-25  Han-Wen  <hanwen@cs.uu.nl>

	* mf/feta-nummer.mf: scalability fixes.

	* mf/feta-nummer-code.mf: fixes for 5, 8. 

	* mf/feta-klef.mf: G clef fixes.

2002-04-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	* scripts/ly2dvi.py: Mats' fix.  Try to import pre if available.

	* scripts/lilypond-book.py: %Newline, rather than glue macros
	after \end{verbatim}.

2002-04-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/user/lilypond-book.itely: 
	* scripts/lilypond-book.py: Add options [no]indent, linewidth and
	noinline.

	* input/mozart-hrn3-defs.ly (startGraceContext): Customize grace init.

	* scm/grob-property-description.scm (beam-space): Junk.

	* lily/beam.cc (space_function): New method.
	(get_interbeam): Call space-function.

	* scm/grob-description.scm (Beam): Initialize space-function with
	Beam::space_function.

	* ly/grace-init.ly (startGraceMusic, stopGraceMusic): Set/revert
	Beam.space-function.  Don't quantise grace beams.

2002-04-23  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION: 1.5.54 released

   	* mf/feta-nummer-code.mf (code): tweaks for three, fixes for 6
	bulb. 

	* Documentation/index.texi: add PDF links.

	* Documentation/user/GNUmakefile (PDF_FILES): add PDF files to website.

	* lily/system-start-delimiter-engraver.cc (acknowledge_grob):
	compare #'glyph as strings. 

	* scripts/lilypond-book.py: fix by Mats. Try to import pre if available.

	* scripts/ly2dvi.py (setup_environment): fix by Mats.

	* lily/stem.cc (head_count): Change function name. Change property
	to #'note-heads i.s.o.  #'heads.
	(position_noteheads): Kern noteheads for invisible stems.
	(before_line_breaking): Do position_noteheads() for whole note
	heads too.

	* lily/accidental-placement.cc (position_accidentals): First
	determine refpoints, only then determine extents.  

2002-04-22  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/accidental-placement.cc (position_accidentals): use all
	note heads for note head-skyline. 

	* scripts/lilypond-book.py (re_dict): remove all *? regexps.

2002-04-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/windows/setup.hint (requires): Add gsview dependency.

	* scripts/lilypond-book.py (re_dict): Fix for python 2.x.

	* lilypond-mode.el (LilyPond-xdvi-command): Default to plain xdvi.

	* input/mozart-hrn3-allegro.ly: Bugfix: include defs.

2002-04-22  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* mf/feta-schrift.mf: lighter staccato.

2002-04-22  Han-Wen  <hanwen@cs.uu.nl>

	* mf/feta-nummer-code.mf (code): fixes for 3 glyph.

2002-04-21  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.53 released

	* scm/lily.scm (ly-load): use primitive-load for loading.

	* lily/misc.cc: remove quantise_iv()

	* lily/*.cc: pass read-only arrays by reference.
	
	* lily/grob.cc (common_refpoint_of_array): new function. Try to
	use common_refpoint_of_{array, list} when possible.

	* lily/include/accidental-placement.hh: new file.

	* lily/accidental-placement.cc (alignment_callback): position
	accidentals in a better way.

	* lily/skyline.cc: new file. Compute distances for collections of
	boxes.

	* lily/include/skyline.hh: new file

2002-04-20  Han-Wen  <hanwen@cs.uu.nl>

	* lily/accidental.cc (class Accidental_interface): grob for a
	single accidental.

	* lily/accidental-engraver.cc (number_accidentals): Cleanups. Lots
	of reformatting

	* lily/new-accidental-engraver.cc (acknowledge_grob): Work
	together with new accidental-interface. 

	* lily/include/*.hh: remove spurious set_interface() decls.

	* lily/key-signature-interface.cc (brew_molecule): add padding for
	natural signs. Make natural typesetting like the sharp.
	

	* mf/feta-klef.mf: rewrote portion of the G-clef code. Downstroke
	is now slightly curved, not straight.
	

2002-04-18  Heikki Junes <hjunes@cc.hut.fi>

	* lilypond-mode.el: Toggles font-lock-multiline (Emacs 21.1 or newer).

	* lilypond-font-lock.el: Handles multiline-strings. Fontifies notes 
	more strictly. Use more clever regular expressions. Commented regexps.

2002-04-16  Heikki Junes <hjunes@cc.hut.fi>

	* lilypond-mode.el: "C-c f" does font-lock-fontify-buffer.

2002-04-15  Juergen Reuter  <reuter@ipd.uka.de>

	* scm/grob-description.scm, lily/staff-symbol.cc: added properties
	to control width of staff symbol in ragged-right mode (by request
	of Han-Wen)

	* ly/engraver-init.ly, lily/include/my-lily-parser.hh,
	lily/include/ligature-bracket.hh, lily/lexer.ll, lily/parser.yy,
	lily/ligature-bracket.cc, lily/ligature-bracket-engraver.cc:
	added support for ligature brackets (needed when transcribing
	mensural music)

2002-04-15  Heikki Junes <hjunes@cc.hut.fi>

	* lilypond-font-lock.el: Handle scheme-slurs up to seventh level.
	Fontify notes more strictly.

2002-04-15  Han-Wen  <hanwen@cs.uu.nl>

	* mf/feta-din-code.mf: dynamic z sign.

2002-04-13  Heikki Junes <hjunes@cc.hut.fi>

	* lilypond-mode.el: Prevent recoloring strings and comments.

	* lilypond-font-lock.el: Handle block comments: block comments
	can have also ordinary comments inside.
	
2002-04-13  Han-Wen  <hanwen@cs.uu.nl>

	* lily/stem.cc (get_default_dir): set direction to CENTER if
	invisible. Various other fixes to deal with invisible stems and
	stem-direction == CENTER.

	* lily/rest-collision.cc (do_shift): take direction from note if
	not set.

	* input/regression/tie-grace.ly: new file.

	* lily/tie-engraver.cc (create_grobs): fix tied graces.

	* lily/note-spacing.cc (stem_dir_correction): set fixed space for
	knee correction. Fixes tight spacing for knees.

2002-04-12  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION: 1.5.52 released
	
	* lily/*.cc: add some undocced properties.
	scm/grob-description.scm: idem.

2002-04-12  Heikki Junes <hjunes@cc.hut.fi>

	* lilypond-font-lock.el: Handle slurs \( and \), numbers,
	multi-measure rests like "R1 *4" and scheme (typically has '#' 
	in the beginning). Small fixes. Add few reserved words.

2002-04-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/topdocs/INSTALL.texi: Updates for MacOS X and
	emacs mode.

	* Documentation/windows/installing.texi: Suggest gswin32c (console
	program) for getting the version.  Layout fixes.

2002-04-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/user/tutorial.itely (Running LilyPond):  Separate
	windows viewing commands, remove silly comment about Yap.

2002-04-10  Mats Bengtsson  <matsb@s3.kth.se>
	
	* Documentation/topdocs/INSTALL.texi: Describe how to learn
	configure to find kpathsea on for example Slackware 8.0.

	* scripts/ly2dvi.py (non_path_environment): Set $TEXMF correctly.

        * scm/grob-description.scm (MultiMeasureRest): number-threshold=1
        by default: avoid "1" over single bar rests.

	* scripts/lilypond-book.py (LatexPaper.set_geo_option): Simplify
	and correct the handling of geometry options.

2002-04-10  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/include/grob-interface.hh (ADD_INTERFACE): make
	implementation for Class::has_interface automatically. Junk all
	other implementations.

	* lily/grob.cc (internal_get_grob_property): also typecheck
	property reads. Catches even more undocced properties. Bugfixing
	left for the uninspired masses.

	* lily/beam.cc: remove end_after_line_breaking().

	* lily/grob.cc (calculate_dependencies): remove list support for
	callbacks.

	* lily/font-size-engraver.cc: only do font-interface.

2002-04-10  Heikki Junes <hjunes@cc.hut.fi>

	* lilypond-font-lock.el: Handle notes with cautionary accidentals.
	  Add few keywords.

2002-04-09 Chris Jackson <chris@fluffhouse.org.uk>

	* lily/arpeggio.cc: New function brew_chord_bracket to draw chord
	brackets using arpeggio requests.
	
	* ly/property-init.ly: Shorthand \arpeggioBracket defined as the
	molecule-callback to use for drawing the brackets.

	* Documentation/user/refman.itely: 
	* input/test/chord-bracket.ly: Chord brackets documented
	
2002-04-10  Han-Wen  <hanwen@cs.uu.nl>

	* mf/feta-din-code.mf: tweaks for p, s. New dynamic r sign. 

	* mf/feta-eindelijk.mf: tweak for eighth rest: move bulb up.

2002-04-09  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/tuplet-bracket.cc (after_line_breaking): bugfix for forced
	direction tuplets on beams.

2002-04-08  Chris Jackson <chris@fluffhouse.org.uk>

	* lilypond-indent.el: Bugfix of indentation of final point in buffer

2002-04-09  Heikki Junes <hjunes@cc.hut.fi>

	* lilypond-mode.el: new command: LilyPond-un-comment-region.
	Added 2Midi to "Command"-menu. Inspired by latex.el and tex.el: 
	separate "Command"-menu and "LilyPond"-menu. Added "Miscellanous"-
	submenu to "LilyPond"-menu.

	* lilypond-mode.el: Added "Midi all" to "Command"-menu, i.e.,
	an interface to play midi.

2002-04-08  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* input/regression/script-stack-order.ly: new file.

2002-04-08  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION (MY_PATCH_LEVEL): Release 1.5.51.

	* mf/feta-din-code.mf: kerning for dynamics.

2002-04-07  Han-Wen  <hanwen@cs.uu.nl>

	* input/regression/dynamics-glyphs.ly: new file

	* mf/feta-din-code.mf: dynamic tweaks. New dynamic s.

	* mf/feta-nummer-code.mf: another bulb routine: mimic the bulb of
	forte f for the 2 number. Some fixes for the other bulbed glyphs.

	* Documentation/windows/gs-profile.sh:
	* Documentation/windows/gsview-profile.sh: Remove.  Functionality
	moved to gs/gsview windows packages.

2002-04-06  Mats Bengtsson  <matsb@s3.kth.se>

	* lily/stem-engraver.cc (acknowledge_grob): Revert to old way of
	finding out the duration. Fixes chord tremolo bug. 

	* lily/completion-note-heads-engraver.cc (process_music): Set
	correct duration for all requests of the broken notes.

	* input/regression/completion-heads.ly: Added example of
	Completion_heads_engraver.

	* lilypond-mode.el: Added "2Midi" command

2002-04-06  Chris Jackson <chris@fluffhouse.org.uk>

	* lily/tuplet-bracket.cc, scm/grob-description.scm: New
	edge-width, edge-height and shorten-pair properties for tuplet
	brackets.

	* lilypond-indent.el: Support for blinking of matching parentheses
	
	* lilypond-font-lock.el: Fix fontification of closing > on its own line
	
	* lily/piano-pedal-engraver.cc, lily/text-spanner.cc: Fixes and
	cleanups of piano pedal brackets.

2002-04-05  Han-Wen  <hanwen@cs.uu.nl>

	* mf/cmbase.mf: remove file. -- do without s, r and z signs for now.

2002-04-04  Han-Wen  <hanwen@cs.uu.nl>

	* mf/feta-new-code.mf:  new dynamic f sign.
	new dynamic m sign.

2002-04-03  Han-Wen  <hanwen@cs.uu.nl>

	* mf/feta-new-code.mf: new dynamic p sign.

2002-04-02  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/note-spacing.cc (stem_dir_correction): only do
	beam-correction if a beam is there. 

	* lily/stem.cc (duration_log): change from flag_i (); better
	naming.
	(get_default_stem_end_position): fix dot/flag collision code.

2002-04-02  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: release 1.5.50

	* lily/spaceable-grob.cc (add_spring): change incorrect spring to
	unit spring here. Reduces number of warning messages.

	* lily/auto-beam-engraver.cc: change noAutoBeaming to autoBeaming.

2002-04-01  Han-Wen  <hanwen@cs.uu.nl>

	* scm/generic-property.scm: remove generic-property, property-engraver

	* lily/volta-bracket.cc (brew_molecule): use Lookup::line() for bracket

	* lily/hairpin.cc (brew_molecule): use Lookup::line() for hairpins.

	* ps/music-drawing-routines.ps: remove volta, tuplet, hairpin routines.

	* scm/*.scm: remove volta, hairpin and tuplet functions.

	* lily/rhythmic-column-engraver.cc (acknowledge_grob): don't make
	note column for notes/stems/dots that already have parents. Fixes
	nested grace contexts.

2002-04-01  Jan Nieuwenhuizen  <janneke@gnu.org>

	* input/mozart-hrn-3.ly: Tweak Slur.beautiful, so that we don't
	get too curved slurs.

	* scm/slur.scm (default-slur-extremity-offset-alist) 
	(default-phrasing-slur-extremity-offset-alist): Move slur
	attachments further away from note-head, vertically.  Also, leave
	a horizontal gap between slur and stem end.

	* lily/beam.cc (get_interbeam): Bugfix: don't look in empty list.

2002-04-01  Han-Wen  <hanwen@cs.uu.nl>

	* input/regression/spacing-grace-duration.ly: new file

	* lily/spacing-engraver.cc (acknowledge_grob): ignore grace notes
	for shortest durations.

	* lily/multi-measure-rest.cc (set_spacing_rods): tune rods to the
	extent of the mm rest. 

	* lily/spacing-spanner.cc (get_duration_space): better spacing for
	really short notes.

	* lily/tuplet-bracket.cc (make_bracket): new function
	(get_x_offset): new function; make tuplet brackets align on stems
	if stem has same direction.
	(parallel_beam): be anal about matching bracket to tuplet.

	* lily/lookup.cc (line): new function Lookup::line(). 

	* scm/tex.scm (dashed-line): change -line to -system in names.

	* lily/box.cc (add_point): new function.

	* flower/include/interval.hh: new function add_point ().
	new function widen()
	
2002-04-01  Jan Nieuwenhuizen  <janneke@gnu.org>

	* input/mozart-hrn-3.ly: Mimic Breitkopf fonts and padding.

	* scm/grob-property-description.scm (number-threshold): Add
	description.

	* lily/multi-measure-rest.cc (brew_molecule): Only put number over
	rest if #measures > number-threshold.  Use padding (well, fake
	using it, anyway).

	* scm/font.scm (make-style-sheet): New styles: mark-number,
	mark-letter.
	(paper20-style-sheet-alist): Add bigger bold fonts.

	* lily/mark-engraver.cc (process_music): Use style mark-number or
	mark-letter.

	* .cvsignore: Ignore all kinds of lilypond input and output.

	* lily/beam.cc (ADD_INTERFACE): Add concaveness-gap.

2002-04-01  Han-Wen  <hanwen@cs.uu.nl>

	* lily/staff-symbol.cc (brew_molecule): make line thickness
	adjustable.

	* lily/*.cc: replace stafflinethickness by linethickness.

2002-04-01  Jan Nieuwenhuizen  <janneke@gnu.org>

	* input/regression/beam-concave.ly: Add to-be-considered-concave
	beam.

	* lily/beam.cc (check_concave): Add check for large gap between an
	inner notehead and the line through outer noteheads.

	* scm/grob-description.scm (Beam): Add concaveness-gap, default
	value 2.0 staff-space.
	
	* scm/grob-property-description.scm (concaveness-gap): Add
	description.

	* input/mozart-hrn3-allegro.ly: Fix typo.

2002-03-31  Juergen Reuter  <reuter@ipd.uka.de>

	* scm/ps.scm, ps/music-drawing-routines.ps, lily/lookup.cc,
	lily/note-head-engraver: improved implementation of roundfilledbox
	(according to Han-Wen's request)

	* lily/include/spacing-spanner.hh, lily/spacing-spanner.cc,
	lily/gourlay-breaking.cc, lily/staff-symbol.cc,
	lily/simple-spacer.cc: ragged-right alignment

2002-03-29  Han-Wen  <hanwen@cs.uu.nl>

	* input/regression/spacing-note-flags.ly: new file

	* input/regression/spacing-rest.ly: new file

	* mf/feta-eindelijk.mf: make bbox of quarter rest tighter.

	* lily/spacing-spanner.cc (note_spacing): make note spacing after
	all grace notes tight (not only the column directly following a
	grace note).

	* scm/grob-description.scm (all-grob-descriptions): don't make
	mm-rests larger than normal.

	* mf/feta-banier.mf: make upflag narrower. Make end of flag more
	curved. Remove white space at the right of flags.

2002-03-28  Jan Nieuwenhuizen  <janneke@gnu.org>

	* ports/ports.make: Bugfix: ignore CVS directories.

	* stepmake/.cvsignore: New file.

2002-03-28  Han-Wen  <hanwen@cs.uu.nl>

	* lily/note-spacing.cc (stem_dir_correction): don't correct when
	there is a flag on the stem.

	* lily/multi-measure-rest.cc (brew_molecule): variable width molecule.

	* scm/grob-property-description.scm (measure-length):
	measure-length grob property.

	* lily/spacing-spanner.cc (standard_breakable_column_spacing):
	better spacing for breakable columns when they're juxtaposed: use
	measure length if applicable

	* lily/timing-engraver.cc (start_translation_timestep): store
	measure length in breakable column at start of measure.

2002-03-28  Jan Nieuwenhuizen  <janneke@gnu.org>

	* ROADMAP: Add description for ports dir, to check email upon
	commit.

2002-03-27  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.48 released
	
	* lily/multi-measure-rest.cc (symbol_molecule): split off from
	brew_molecule()
	(set_spacing_rods): Use symbol_molecule() to determine minimum
	width
	(church_rest): split off from brew_molecule()
	(big_rest): split off from brew_molecule(). Construct using
	variable shape.
	
	* mf/feta-eindelijk.mf: junk multi measure rest.

2002-03-26  Han-Wen  <hanwen@cs.uu.nl>

	* lily/multi-measure-rest.cc (add_column): remove columns property.

	* lily/dynamic-engraver.cc (process_music): add more verbose warning

	* input/mozart-hrn3-romanze.ly (romanze): add mozart horn concerto
	3 as test piece.

2002-03-26  Heikki Junes <hjunes@cc.hut.fi>

	* lilypond-font-lock.el (LilyPond-font-lock-keywords): most new
	keywords covered, dropped some non-keywords, include R- and 128-notes

2002-03-25 Juergen Reuter <reuter@ipd.uka.de>

	* Code clean-up: Junk multiple implementations of ledger line
	creation in note_head, custos, and porrectus.  This is important
	since there soon will be some more applications of ledger lines to
	come (e.g. ambitus engraver).

	* Make thickness of ledger lines adjustable.  This is essential
	for mensural notation.

	* Fix some bugs in the current ledger_line implementation, most
	notably that of the horizontal extent of ledger lines which equals
	at least the extent of the metafont ledger_line character, and
	which grows(!) if the desired extent shrinks below this limit.

	* roundfilledbox: variable blotdiameter

2002-03-24  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.47 released

	* lily/line-spanner.cc (line_atom): change line-thickness to thickness

	* lily/porrectus.cc:  change line-thickness to thickness, change
	stem-direction to direction.

	* scm/backend-documentation-lib.scm (check-dangling-properties):
	Automatically detect doc'ed properties that are not in an interface

	* scm/grob-property-description.scm: property cleanup. Remove many
	paper-column props that are non-existent.

	* lily/grob.cc (Grob): only use molecule_extent_proc as default if
	the grob has a molecule-callback.

	* lily/*.cc: remove many set_interface() calls, and their
	implementations.

	* input/regression/spacing-knee.ly: new file

	* input/regression/spacing-clef-first-note.ly: new file

	* lily/staff-spacing.cc (get_spacing_params): different spacing
	for pref matter to note at start of line, halfway during line.

	* lily/note-spacing.cc (stem_dir_correction): apply 2nd stem direction
	correction only if stems have same direction (i.e. not for
	stem-clef combination).
	(stem_dir_correction): maximal correction for knees.

	* lily/*.cc: many updates to interface descriptions.
	
	* lily/grob.cc (internal_set_grob_property): add interface check
	for every set_grob_property call

	* lily/*.cc: document interface stuff in C++
	
	* lily/grob-interface.cc: new file. Add grob interfaces from C++. 

	* lily/volta-bracket.cc: naming: change volta spanner to
	volta-bracket.

	* input/bugs/*.ly: cleanup, remove lots of files.
	
	* buildscripts/mf-to-table.py (write_ps_encoding): generate
	.encoding file. WARNING: upgrade to pktrace 1.0.3

	* mf/feta-toevallig.mf: change PS name for parentheses.

2002-03-23  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

       * scripts/ly2dvi.py (ly_paper_to_latexpaper): Use the correct unit
       also for textheight

2002-03-23  Han-Wen  <hanwen@cs.uu.nl>

	* lily/scope.cc: remove file .

	* lily/include/scope.hh: remove file. Remove Scope class

	* VERSION: 1.5.46

	* lily/beam.cc (score_slopes_dy, score_stem_lengths,
	score_forbidden_quants): ): take out of SCM, pass parameters so
	grob props are read only once. (wtk1-fugue2 from 31 sec to 14
	secs).
	(calc_stem_y): robustness: take care of last_visible_stem == 0.


	* lily/lily-guile.cc (ly_unit): return internal unit.

	* scm/tex.scm (header-end): insert scaling factor, using ly-unit 

	* lily/paper-outputter.cc (output_version): output internal unit
	from Paper_outputter

	* scripts/ly2dvi.py: Read unit from paper vars (43.jcn3).

2002-03-22  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

       * scripts/ly2dvi.py: clean up old .*pk font caching code.

       * scm/ps.scm: Use uppercase postscript font names for the standard
       TeX fonts.

       * scripts/ly2dvi.py, buildscripts/lilypond-{login,profile}.sh, :
       Add all available TeX Type1 fonts, including Feta, to the
       Ghostscript font path.

       * Documentation/topdocs/INSTALL.texi (Top): Add required pktrace
       version (affects the FontName) in lilypond.map.

       * mf/GNUmakefile, Documentation/user/appendices.itely: Rename font
       documentation file to fetaNNlist.ly to avoid name collisions between
       lilypond generated .tex file and font .tex macros file.


2002-03-22  Juergen Reuter <reuter@ipd.uka.de>

	* mf/feta-eindelijk.mf, mf/parmesan-rests.mf: added maxima rests;
	made mensural longa and (semi-)brevis leaner

	* mf/parmesan-clefs.mf, scm/clef.scm: enhanced petrucci c clef

	* lily/{{lookup,porrectus}.cc,include/{lookup,porrectus}.hh}: code
	clean-up: moved bezier shape and slope from porrectus to lookup

	* buildscripts/clean-fonts.sh: added search paths /var/cache/fonts
	and /usr/share/texmf/fonts

	* scripts/ly2dvi.py: Read unit from paper vars (43.jcn3).

2002-03-22  Han-Wen  <hanwen@cs.uu.nl>

	* lily/text-spanner.cc (brew_molecule): add #'thickness
	(brew_molecule): add corrections for thickness in molecule padding.

	* lily/line-spanner.cc (line_atom): make function private

	* scripts/lilypond-book.py (get_bbox): Use GS -sDEVICE=bbox to
	discover bounding box. This solves the cropping problem.

	* lily/bar-check-iterator.cc (process): Only resynchronize bar
	check when it  fails. This fixes the combination of  grace notes
	and bar checks.

2002-03-21  Han-Wen  <hanwen@cs.uu.nl>

	* lily/repeated-music.cc (minimum_start): new Scheme callable function
	(first_start): new Scheme callable. This will fix repeated music
	starting with grace notes.

	* lily/music.cc (start_mom): check start-moment-function grob property.

	* VERSION: 1.5.45 released

	* input/regression/system-extents.ly: new regression test. Test
	System extents. 

	* lily/system.cc: rename LineOfScore into System 

	* lily/molecule.cc (ly_add_molecule): new Scheme ly-add-molecule.

	* lily/grob.cc (ly_get_parent): new Scheme function ly-get-parent.
	(ly_get_extent): new Scheme function ly-get-extent

	* ps/lilyponddefs.ps: use output-scale for  line-x
	definition. 

	* scm/ps.scm (font-load-command): 
	use output-scale

2002-03-20  Rune Zedeler <rune@zedeler.dk>
	
	* lily/beaming-info.cc: Stupid typo fixed
	
	* lily/accidental-engraver.cc: rewrote accidental-routines to get
	support for cross-context auto-accidentals.
	Now the engraver can stay in Staff-context and see other contexts
	from there.
	Changed properties: autoAccidentals, autoCautionaries

	* lily/translator-group.cc (set_children_property):
	Function added recursively setting the same property (deep_copied)
	for all children of a Translator_group.
	
	* ly/property-init.ly: added commands
	\pianoAccidentals \voiceAccidentals
	\modernVoiceAccidentals \modernVoiceCautionaries

	* ly/engraver-init.ly: Correct initialization of new accidentals.
	
	* scm/translator-property-description.scm: Updated
	
	* input/regression/accidental-voice.ly: Added
	
	* Documentation/regression-test.tely: Added new test	

2002-03-19  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION: 1.5.44 released

	* lily/slur.cc (set_extremities): robustness fixes for #'attachment.

	* scripts/lilypond-book.py (bounding_box_dimensions): bugfix.

	* ly/params-init.ly (blotdiameter): use unit for blotdiameter, set
	at 0.4 pt.

	* tex/feta*.tex: remove.
	
	* stepmake/aclocal.m4: remove stepmake symlink. It confuses almost
	all software dealing with it.

2002-03-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	* mf/GNUmakefile (lilypond.map): Don't prepend TeX to font name
	(this fixes pdf output).  Drop awk dependency.

	* scripts/ly2dvi.py (ly_paper_to_latexpaper): Assume LilyPond's
	dimensions (linewidth) are in mm.

	* mf/GNUmakefile (depth): Always allow manual access to pfa target.

	* tex/lily-ps-defs.tex: scaletounit using PT/IN==72.

	* lily/slur.cc (get_attachment): Bugfix: correct for stem thickness.

2002-03-19  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.43 released

	* scm/beam.scm (beam-dir-majority-median): if majority is
	undecided, use median. Removes a forced dir in sarabande.

	* mf/feta-schrift.mf: Trill fixes, Vee fixes (upbow, ltoe, rtoe)

2002-03-18 Chris Jackson <chris@fluffhouse.org.uk>
 
 	* lily/text-spanner.cc, lily/piano-pedal-engraver.cc: Cleanups. Edge
 	widths, heights and shortens are now customisable properties.
 
 	* scm/grob-description.scm, scm/grob-property-description.scm: New
 	properties added to PianoPedalBracket, unnecessary
 	Y-offset-callbacks removed from *Pedal, undocumented properties
 	fixed.
 
 	* Documentation/user/refman.itely: Piano pedal updates.

2002-03-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	* scm/grob-property-description.scm:
	* scm/interface-description.scm: Remove old stuff.

	* scm/grob-description.scm (StemTremolo): Change beam-thickness to
	0.48 (previously 0.42).
	(Beam): Remove old stuff.

	* lily/stem.cc: 
	* lily/stem-tremolo.cc: 
	* lily/beam.cc: 
	* scm/beam.scm: Remove old stuff.  Use Beam::get_interbeam ()
	(previously space-function).

 	* stepmake/bin/add-html-footer.py: Website title fix.

2002-03-18  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* scripts/ly2dvi.py (environment): use new font searching setup.

	* lily/afm.cc (afm_bbox_to_box): make code dimension independent

	* lily/tfm.cc (dimensions): make code dimension independent

	* ps/lilyponddefs.ps: add constant for MM and true/ps-point
	scaling

	* tex/lily-ps-defs.tex: scaling for PS points and MM.

	* lily/include/dimensions.hh: try MM as internal unit.

	* scm/*.scm: remove invoke-dim1

2002-03-17  Han-Wen  <hanwen@cs.uu.nl>

	* GNUmakefile.in (fontpaths): add fontpaths target,

	* make/mutopia-targets.make: add PDF rules.

	* make/mutopia-rules.make: add pdf rule.

	* buildscripts/mutopia-index.py (list_item): add PDF.

	* buildscripts/lilypond-profile.sh (TEXMF): typo.

	* make/lilypond-vars.make: set TEXMF for the new font setup.
 
2002-03-17  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.42 released
	
	* mf/feta-schrift.mf: endless twiddling of Tr.

	* mf/feta-eindelijk.mf: 8th rest: make darker, top of brush lower, and
	endless twiddling with the bulb shape.

	* lily/note-head.cc (internal_brew_molecule): make ledger lines a
	little smaller if there is an accidental.

2002-03-15  Mats Bengtsson  <mats.bengtsson@s3.kth.se>
 
 	* buildscripts/lilypond-profile.sh: 
 
 	* mf/GNUmakefile (INSTALLATION_OUT_DIR*),
 	buildscripts/lilypond-login.sh, buildscripts/lilypond-profile.sh:
 	Implement new font installation strategy
 
 	* Documentation/misc/fontinstallation (TEXMF): Documentation of
 	the new font installation strategy.
 
 	* lilypond-mode.el (LilyPond-mode-map): Add shortcut "CTRL-c ;"
 	for comment-region.
 
 	* input/test/staff-size.ly: Simplified using StaffContainer
 
 	* mf/GNUmakefile (ALL_GEN_FILES): Actually generate the
 	lilypond.map file

2002-03-17  Jan Nieuwenhuizen  <janneke@gnu.org>

	* scm/ps.scm (bezier-sandwich): Draw circles at slur ends.

	* lily/beam.cc (score_stem_lengths): new quanting stuff
	(score_forbidden_quants): Second and third beam quant stuff.

2002-03-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/beam.cc (least_squares): Remember least-squares-dy for
	later use.
	(quantise_interval): Don't quant to dy steeper that
	least-squares-dy.  Return empty interval if no sane quants found.
	(quantise_position): Try quantise_interval until we have
	acceptable solution.

2002-03-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	* scm/interface-description.scm (beam-interface): Update.

2002-03-15  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION: 1.5.41 released
	
	* mf/feta-schrift.mf: make Tr. smaller, smoother and closer.  Use
	optima serifs on top of t, bottom of r.

	* mf/feta-bolletjes.mf: make ledger line rounder. 

	* mf/feta-toevallig.mf: some smallish fixes for flat sign.

	* mf/feta-eindelijk.mf: make 8th rest a little darker, some more
	parametrization.

2002-03-15 Chris Jackson <chris@fluffhouse.org.uk>
 
       * lily/piano-pedal-engraver.cc: Rewritten to support bracketed as
       well as text pedal indications and a combination of both.  All
       pedal indications are horizontally aligned on a line spanner.
 
       * lily/text-spanner.cc: Edge-width property added to use in
       bracketed piano pedals. Function setup_sustain_pedal added to set
       the dimensions of the brackets. 
 
       * scm/grob-description.scm: New *PedalLineSpanner grobs added, and 
       some of the *Pedal properties tweaked. 
 
       * scm/grob-property-description.scm: New pedal-type (*Pedal) and
       edge-width (TextSpanner) properties.
 
       * ly/engraver-init.ly: Default strings added for SostenutoPedal. 
 
       * lilypond-font-lock.el: sostenuto, unaCorda and treCorde added to
       fontified identifiers list.
 
       * input/test/pedal.ly: New pedal features added. 
 
       * Documentation/user/refman.itely: New pedal features documented.
       

2002-03-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/include/new-beam.hh: Previously new-beam.hh
	* lily/beam.cc: Previously new-beam.cc
	(least_squares): Bugfix: don't barf on beams with less than two
	visible stems (tremolos).

	* scm/beam.scm: 
	* scm/grob-description.scm (Beam): Junk old beam stuff.
	
	
2002-03-14  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION: 1.5.40

	* mf/feta-eindelijk.mf: new 8th rest.

	* mf/feta-toevallig.mf: small fixes for the sharp symbol. Don't
	stick out of staffline

	* scripts/lilypond-book.py: fixes for texi regular expressions.

2002-03-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/include/new-beam.hh:
	* lily/new-beam.cc: New file.

	* flower/include/interval.hh: 
	* flower/include/interval.tcc (delta): New method.
	(swap): Now public (previously private).
	
	* scm/beam.scm (default-beam-y-quants): Bugfix: lower beam-sit by
	1 staff-line-thickness.  Sadly, this makes dy quanting problems
	(dy quants allowed should depend on actual left y) more visible.

2002-03-13  Jan Nieuwenhuizen  <janneke@gnu.org>

	* lily/beam.cc (quantise_dy): Bugfix: sign (0) = 0.  Hmm.

	* scm/grob-property-description.scm (concaveness-threshold): Add
	typecheck and description.

	* scm/grob-description.scm (Beam): Remove obsolete properties, add
	concaveness-threshold (previously concaveness).

	* lily/beam.cc (check_concave): Remove choices and debugging
	stuff: use best concaveness calculation.
	(quantise_dy): Remove choice.  Try to never make a slope steeper
	by quantising, but certainly never quantise a slope away.
	(check_stem_length_f): Remove choice.  In case of lengthening
	alowed, always lengthen to ideal length.

	* Documentation/index.texi: Fix FAQ url.

	* Documentation/topdocs/INSTALL.texi: Add information about fink,
	compile fix and 1.4 specific fix that doesn't hurt 1.5.

2002-03-13  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.39 released

	* lily/simple-spacer.cc (add_rod): rods take precedence over
	infinitely stiff springs. This fixes bugs with arpeggios and bar-lines.

	* lily/arpeggio-engraver.cc (acknowledge_grob): clean up.

	* lily/note-spacing.cc (get_spacing): only insert space for
	accidentals if necessary.

	* input/regression/spacing-accidental-staffs.ly (texidoc): update example

	* lily/spacing-spanner.cc (musical_column_spacing): new
	function. Have correct spacing from note to end-of-line as well.

2002-03-12  Jan Nieuwenhuizen  <janneke@gnu.org>

       * Documentation/topdocs/INSTALL.texi: Add section for MacOS X.

       * darwin.patch: New file.

       * lily/beam.cc (set_stem_shorten): Revive deceased stem shorten
       code.  Shorten stems by fraction of stems to be shortened.

       * lily/stem.cc (get_default_stem_end_position): Shorten only half
       of shorten value for boundary cases.

       * scm/grob-description.scm (Stem): Set stem-shorten to (1.0 0.5).
       (Beam): Set beamed-stem-shorten to (1.0 0.5).

2002-03-11  Jan Nieuwenhuizen  <janneke@gnu.org>

       * lily/beam.cc (check_stem_length_f): Try to lenthen more.

       * scm/grob-description.scm (Beam): Add concaveness.  Replace
       Beam::cancel_suspect_slope with Beam::check_concave.
 
       * lily/beam.cc (check_concave): Calculate concaveness of beam, and
       set slope to horizontal if concaveness > Beam.concaveness.  This
       handles cases that kludgy cancel_suspect_slope was meant to catch
       very well.
       (cancel_suspect_slope): Remove.

2002-03-12 Rune Zedeler <rune@zedeler.dk>

 	* lily/beam.cc lily/stem.cc lily/beam-engraver.cc: allow for
 	stemLeftBeamCount and stemRightBeamCount to equal 0.
 	Fixes [c8 c4 c8]
      
2002-03-12  Han-Wen  <hanwen@cs.uu.nl>

	* lily/spacing-spanner.cc (breakable_column_spacing): Only do
	fixed spacing for pref matter, if the next column is musical, and
	at the same moment.

	* lily/note-spacing.cc (stem_dir_correction): Use correct
	discretionary for stem-bar spacing.

2002-03-11  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.38 released 

	* lily/grob.cc (warning): Use cause tracking to give more
	meaningful errors from the backend. 

	* lily/property-iterator.cc (check_grob): Warn if setting grob
	property in unknown grob. 

	* mf/feta-toevallig.mf: brushed stems for natural sign.

	* lily/molecule.cc (align_to): don't translate empty molecule.
	(this triggers a very subtle bug in time-signature.)  

2002-03-10  Han-Wen  <hanwen@cs.uu.nl>

	* lily/spring.cc: remove file.

	* input/regression/spacing-stem-bar.ly: new file

	* lily/score.cc (run_translator): resurrect point-and-click

	* input/baerenreiter-sarabande.ly: Copy Barenreiter beaming for
	sarabande layout

	* lily/spacing-spanner.cc (find_shortest): Shortest note for
	spacing is now globally determined, using the most common shortest
	note. Notes that are shorter are spaced geometrically, and with
	expand hints. This makes spacing more even, and measures that have
	very short notes won't be that stretched out.  

	* mf/feta-klef.mf: F-clef fixes, documentation on the
	shape. (WARNING: font changed.)

2002-03-09  Han-Wen  <hanwen@cs.uu.nl>

	* lily/simple-spacer.cc (add_columns): support for infinitely
	stiff springs.
 
	* lily/staff-spacing.cc (get_spacing_params): space after
	prefatory matter is fixed.

2002-03-08  Han-Wen  <hanwen@cs.uu.nl>

	* lily/note-spacing.cc (stem_dir_correction): Correct spacing for
	barline following an upstem.

	* lily/staff-spacing.cc (extremal_break_aligned_grob): destill
	function from next_notes_correction().
	(bar_y_positions): idem.

2002-03-04  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* input/regression/break.ly (texidoc): bugfix: escape \ in
	strings.

	* lily/staff-spacing.cc (next_notes_correction): Correct the
	spacing of a note following a barline.

2002-03-04  Glen Prideaux

	* mf/feta-solfa.mf: Shaped note heads

2002-03-03  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.37 released

	* lily/key-signature-interface.cc (brew_molecule): rename from key_item
	left-align molecule.
	
	* lily/break-align-interface.cc (do_alignment): completely
	rewritten. Now it does not use Align_interface anymore, but a
	separate routine. Like StaffSpacing, it reads space-alist from the
	breakable grobs.  This allows you to set spacing using
	
	\property Staff.Clef \override #'space-alist = '(....stuff....)  
 
	* lily/bar-line.cc, lily/include/bar-line.hh: change name from Bar
	to Bar_line. Move files around as well.

	* lily/time-signature.cc (time_signature): left align time signatures. 

	* mf/feta-timesig.mf: Remove padding from C-style time signatures.
	Corrections of the glyph shape C. Comments added.

2002-03-02  Han-Wen  <hanwen@cs.uu.nl>

	* lily/spacing-spanner.cc: move from third-try.cc; rename
	Third_spacing_spanner to Spacing_spanner.

	* lily/staff-spacing.cc (get_spacing_params): redo prefatory
	spacing stuff. Much cleaner now, and we prepare for neat spacing
	tricks around bar lines and such.

	* lily/third-try.cc (prune_loose_colunms): bugfix. Don't init
	variables with themselves. (Ouch.)

	* lily/span-bar.cc (brew_molecule): don't try to span bars that
	overlap.

2002-03-02  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.36

	* lily/lily-guile.cc: isdir_b and isaxis_b changed to ly_axis_p,
	ly_dir_p

	* lily/music.cc (ly_get_mus_property): typechecking
	(ly_set_mus_property): idem
	(ly_make_music): idem
	(ly_music_name): idem

	* lily/chord.cc: use scm_reverse_x iso. gh_reverse()

	* lily/note-spacing.cc (stem_dir_correction): correction for
	same stem notes as well. 

	* lily/pitch.cc (pitch_transpose): stricter typechecking

	* mf/parmesan*mf: magnification fixes.

	* Documentation/topdocs/INSTALL.texi: update RedHat reqs

2002-03-01  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

	* buildscripts/mf-to-table.py (postfixes): Output also .ly file
	documenting the font. (Doesn't work for parmesan at the moment)

	* Documentation/user/appendices.itely (The Feta font): Add list of
	Feta font symbols with names.

	* mf/GNUmakefile ($(outdir)/lilypond.map): Generate lilypond.map
	automatically

2002-03-01  Han-Wen  <hanwen@cs.uu.nl>

	* lily/translator-group.cc (ly_set_trans_property): typechecking
	(ly_get_trans_property): typechecking.

	* lily/font-metric.cc (ly_text_dimension): typechecking 
	(ly_find_glyph_by_name): idem.

	* scm/bass-figure.scm (brew-complete-figure): support for
	bracketed numbers.
	
	* lily/grob.cc (ly_get_paper_var): new function

2002-02-28  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION (PATCH_LEVEL): 1.5.35 released.

	* lily/lookup.cc (ly_bracket): Scheme function ly-bracket
	(bracket): New function.

	* lily/stem-engraver.cc (stop_translation_timestep): bugfix, unset
	stemLeftBeamCount, stemRightBeamCount in stead of using #<undefined> 

	* lily/third-try.cc (set_implicit_neighbor_columns): type checking
	bugfix.

	* lily/span-arpeggio-engraver.cc (stop_translation_timestep):
	typecheck bugfix. 

	* lily/grob.cc (ly_get_grob_property): be anal about types.
	(ly_set_grob_property): idem

	* lily/figured-bass-engraver.cc (process_music): move molecule
	building completely to Scheme

	* lily/include/musical-request.hh (class Bass_figure_req): Add
	class. 

	* lily/parser.yy (bass_figure): add support for space figure.

	* lily/molecule.cc (ly_molecule_combined_at_edge): be anal about types 

	* lily/font-metric.cc (ly_text_dimension): Scheme function ly-text-dimension

	* lily/molecule.cc (ly_fontify_atom): new function ly-fontify-atom
	(ly_align_to_x): new function ly-align-to!

	* lily/font-interface.cc (ly_font_interface_get_font): new Scheme
	function ly-get-font

	* mf/feta-nummer.mf: include normal-space dimension. 

	* lily/collision.cc (check_meshing_chords): don't merge collisions
	with whole notes.
	
	* lily/system-start-delimiter.cc (after_line_breaking): Bugfix:
	glyph is string.

2002-02-28  Mats Bengtsson  <matsb@s3.kth.se>

	* scm/tex.scm, scm/ps.scm (or): Bugfix, ps output with Guile 3.4

2002-02-28  Juergen Reuter  <reuter@ipd.uka.de>

	* mf/parmesan-heads.mf: bugfix: mensural note heads  (WARNING:
	font changed)

	* scm/output-lib.scm: bugfix: resort to neo_mensural chars rather
	than mensural chars

	* mf/parmesan-scripts.mf, mf/parmesan-generic.mf,
	scm/grob-description.scm: added mensural fermata symbol

2002-02-27  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION: 1.5.34 released.

	* lily/rest-engraver.cc (create_grobs): rests can have pitches.

	* lily/staff-symbol-referencer.cc (callback): assume that
	staff-position is unset in general.

	* input/regression/rest-pitch.ly: new file.

	* lily/parser.yy (simple_element): rests can have pitch. Syntax:
	a4\rest

2002-02-26  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/scm-option.cc (set_lily_option): add internal-type-checks
	as Scheme option. Run regression test by default with
	internal-type-checking.

	* lily/separating-group-spanner.cc (find_musical_sequences):  removed.

	* lily/lily-guile.cc (type_check_assignment): changed functions.

	* scm/*description*.scm: be anal about typechecks. Some changes
	for internal variable names.

2002-02-25  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* scm/ps.scm: -f ps  output for GUILE 1.4 and 1.3.4

2002-02-25  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.33 released.

	* mf/feta-macros.mf (flare_path): removed draw_flare, replace by
	flare_path everywhere (c-clef, numbers).	

	* lily/bar-number-engraver.cc (process_music): also print bar
	number if measure starts with grace note.	

	* input/regression/grace-bar-number.ly: new test.

2002-02-24  Han-Wen  <hanwen@cs.uu.nl>

	* lily/figured-bass-engraver.cc (stop_translation_timestep): reset
	rest as well.

	* scm/music-functions.scm (voicify-music):  split chords into
	different voices automatically.

	* lily/music.cc (ly_music_list_p): new function

	* lily/music-sequence.cc (do_relative_octave): robustification

	* scm/music-functions.scm: many utility functions 

	* lily/music.cc (ly_set_mus_property): add type checks to the
	Scheme property assignment.

	* buildscripts/lilypond-profile,lilypond-login.sh (TEXCONFIG):
	dvips fixes

	* mf/lilypond.map: .map file from Mats' page. 

2002-02-21  Juergen Reuter <reuter@ipd.uka.de>

	* Some more parmesan related fixes;

	* Custos: varying shape (in particular, stem length), depending on the
	  vertical position of the custos (on staffline / between stafflines);

	* Custos: added grob property "neutral-direction" (same semantics as
	  with stem); introduced new grob property "neutral-position";

	* Time-signature: print a warning when resorting to default layout.

2002-02-22  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/translator-group.cc (add_fresh_simple_translator): remove
	function; initialize() is called through
	Translator_group::initialize().

	* lily/third-try.cc (prune_loose_colunms): add constraints (rods)
	for the neighbors of a loose column.

	* lily/line-of-score.cc (set_loose_columns): be more intelligent:
	position loose columns so that they don't collide.

2002-02-21  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION: 1.5.32 released.

	* scm/font.scm: remove font-name symbol.

	* mf/GNUmakefile: use pktrace for making PFAs

	* make/lilypond.redhat.spec.in: use pktrace when making RPMs

	* lily/rest-collision.cc (do_shift): read direction field from
	rest-column in case of note-rest collision. This should fix some
	problems with rest collisions.

2002-02-19  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/note-heads-engraver.cc (process_music): Removed easyPlay
	property.

	* lily/note-head.cc (brew_ez_molecule): Remove note-character
	property. Read pitch directly from #'cause.

	* mf/feta-puntje.mf: bugfix

2002-02-19  Juergen Reuter <reuter@ipd.uka.de>
	
	* mf/*.mf: tried to fix ancient-font.ly. WARNING: Font changed.

2002-02-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/windows/compiling.texi: Update.

	* Documentation/index.texi: Add link to orphaned compiling for
	windows page.

	* Documentation/footer.html.in: Comment fix.

	* stepmake/bin/add-html-footer.py: Python2.[12] re workarounds.

2002-02-18  Han-Wen  <hanwen@cs.uu.nl>
	
	* VERSION: 1.5.31 released

	* lily/new-spacing-spanner.cc: remove file.

	* lily/third-try.cc (do_measure): only take spacings into account
	if they pertain to the column pair under consideration. This fixes
	spacing bug when mixing eighths triplets and normal eighths.

	* lily/note-head.cc (brew_molecule): revert ledger change: ledger
	lines don't take up space anymore. Document why in note-head.cc
	comment.

2002-02-17  Han-Wen  <hanwen@cs.uu.nl>

	* lily/font-interface.cc (get_font): reinstate
	#'font-magnification. See input/regression/font-magnification.ly
	(get_font): Change the definition of  #'font-name grob property.

	* lily/grob.cc (get_uncached_molecule): output origin for grobs
	that have a #'cause field.

2002-02-12  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* Documentation/topdocs/INSTALL.texi: remove type3 stuff. 

	* mf/GNUmakefile:  remove metapost stuff

	* stepmake/aclocal.m4: remove metapost detection stuff.

2002-02-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	* mf/GNUmakefile (FET_FILES): 
	(FONT_FILES): Include parmesan.

	* stepmake/bin/packagepython.py (make_assign_re): Bugfix.  Use re
	iso regex, regsub

	* buildscripts/clean-fonts.sh (FILES): Clean parmesan too.

	* Documentation/user/refman.itely (Paper size): Quote braces.

2002-02-07  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* stepmake/aclocal.m4: fixed bison version check to be more
	robust.

	* lily/stem.cc (position_noteheads): fix for cluster chords.

	* mf/*.mf: many blotting/pixel rounding fixes  by Rune Zedeler

	* python 2.2 support.

2002-02-04  Han-Wen  <hanwen@cs.uu.nl>

	* VERSION: 1.5.30 released

	* lily/dynamic-engraver.cc: add doco about DynamicLineSpanner

	* Documentation/user/refman.itely (Dynamics): add a note about
	DynamicLineSpanner.

	* scm/grob-description.scm: add a 'translator-type?  object
	property, so that \property Foo.Bar =\turnOff doesn't cause
	type check warning.

	* lily/translator-group.cc (add_fresh_group_translator): make
	new add-translator functions to make distinction between fresh and
	used group-translators. Fixes problem with scripts on auto-changing voice 

	* lily/timing-engraver.cc: make Timing_engraver instantiatable,
	add to Score_performer. Fixes bar checks in MIDI

	* lily/tie-engraver.cc (create_grobs): Use pitches to compare note
	heads. Fixes many quirks with ties.

	* lily/engraver.cc (announce_grob): Use SCM argument. Store cause
	in the grob property #'cause, instead of using Grob_info.

	* ly/engraver-init.ly (StaffContext): move Dot_column_engraver to
	staff context, fixing dot alignment on collisions.

	* lily/beam-engraver.cc (try_music): remove can't find beam start
	warning, so that skipTypesetting won't complain.

2002-02-01  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

	* Documentation/user/refman.itely (Paper size): Documentation fix,
	papersize

	* lily/text-engraver.cc: Bugfix: textNonEmpty works again

	* scm/grob-description.scm: \breathe: Use feta font comma by default

2002-01-23  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

	* input/template/piano-dynamics.ly (pedal): Simplified

2002-01-18  Mats Bengtsson  <mats.bengtsson@s3.kth.se>

	* ly/engraver-init.ly: avoid warnings on \skip in lyrics

2002-01-10  Mats Bengtsson  <matsb@s3.kth.se>

	* lilypond-mode.el (LilyPond-command-query): ignore case.

2002-02-01  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION: 1.5.29 released

	* all files: change 2001 to 2002 in headers globally

	* mf/parmesan20.mf: split out ancient notation into parmesan ("old
	cheese") font. WARNING: fonts changed.
	
2002-02-01  Juergen Reuter <reuter@ipd.uka.de>

	* mf/*.mf: Fixed some blot_diameter related flaws in some feta symbols
	
	* mf/*.mf: Added some more vaticana/solesmes style font symbols
	
	* mf/*.mf: Bugfix: renamed subbipunctum -> inclinatum

	* mf/*.mf: Fixed a few typos in various .mf files

2002-01-17 Rune Zedeler <rune@zedeler.dk>
	
	* mf/: added macro soft_penstroke
	
 	       softened some glyphs
 	       redrawn triangular noteheads
 	       redrawn tab-clef
 	       added classical quarter rest
 	
	* lily/stem.cc: Bugfix: Stem-attachment when staff_space!=1
 
	* lily/bar.cc: Bugfix: repeat dots when even number of staff
 	lines and staff_space>=2
 
	* lily/rest.cc: Use default rests when current style glyphs not
 	found - this allows
 	\property Staff.Rest \override #'style = #'classical

2002-01-30  Jan Nieuwenhuizen  <janneke@gnu.org>

	* input/bugs/first-tie.ly: New file.

	* input/bugs/spacing-clash.ly: New file.

2002-01-29  Jan Nieuwenhuizen  <janneke@gnu.org>

	* po: regenerate.

2002-1-24 Chris Jackson <chris@fluffhouse.org.uk>

	* lilypond-indent.el: New file providing indentation for
	parenthesised blocks of lilypond code in Emacs
	
	* lilypond-font-lock.el: Changes to the syntax table to facilitate
	indentation and handle block comments properly. Distinguish
	accents from close-brackets in fontification.

	* lilypond-mode.el: LilyPond-indent-command set appropriately.

2002-01-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	* Documentation/windows/installing.texi: 
	* Documentation/windows/compiling.texi: Include from 1.4.10.

	* Documentation/windows/gs-profile.sh: previously lily-gs.sh

	* input/bugs/first-midi-tie.ly: New file.

2001-12-29  Han-Wen  <hanwen@cs.uu.nl>
	
	* VERSION: 1.5.28 released

        * lily/parser.yy (My_lily_parser): Slightly kludgy warning for
        illicit beams on [c4 c4] etc.

        * lily/bar-check-iterator.cc (Bar_check_iterator): new
        file. Make separate iterator for Bar_checks. Bar_check now happen
        outside engravers, meaning that you can use them with
        skipTypesetting. Associated changes in other files.
        
        * lily/new-spacing-spanner.cc (stem_dir_correction): removed
        function
        
        * lily/spacing-spanner.cc (stem_dir_correction): removed function

        * lily/include/grob.hh (unsmob_item, unsmob_spanner): Add functions

        * lily/bar.cc (before_line_breaking): remove bar-line spacing code.

        * lily/stem.cc (set_spacing_hints): removed function

        * lily/note-spacing.cc (stem_dir_correction): new stem-direction
        correction for spacing; now take vertical extents of the stem into
        account.  

        * lily/third-try.cc: More hacking to get spacing working.

        * lily/note-spacing-engraver.cc: new file, Note_spacing_engraver
        sits at staff level and creates note spacing objects. Scrap it
        again, and document why.

        * lily/include/group-interface.hh: rename functions. 

2001-12-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	* stepmake/stepmake/c++-rules.make:
	* stepmake/stepmake/c-rules.make: Fixes for bison-1.28.

2001-12-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	* make/lilypond-vars.make: 
	* scripts/ly2dvi.py (setup_environment): 
	* scripts/lilypond-book.py (setup_environment): Also set tex
	memory options.

2001-12-24  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* VERSION: 1.5.27 released.

	* Documentation/user/refman.itely (Bar numbers): added bar number
	documentation.

	* scm/font.scm (make-style-sheet): Fixes to make staff-sizes work
	again.

2001-12-22  Mats Bengtsson  <matsb@s3.kth.se>

	* tex/lilyponddefs.tex: Make sure interscorelinefill=1 doesn't
	spread the last few lines all over the last page of a score.

2001-12-24  Han-Wen  <hanwen@cs.uu.nl>

	* lily/third-try.cc: 3rd try at revising spacing
	engine. Not yet finished.

	* lily/paper-column.cc (brew_molecule): print debugging marks on a
	paper-column.

	* lily/tie-engraver.cc (class Tie_engraver): Use busyGrobs for
	collecting past note heads.

	* lily/note-heads-engraver.cc (try_music): Remove end_mom_
	stuff.

	* lily/grob-pq-engraver.cc (class Grob_pq_engraver): New file, new
	class. Keep a queue of grobs that are still playing in busyGrobs. 

	* lily/lyric-combine-music-iterator.cc (get_busy_status): New
	function. Use busyGrobs to detect playing notes.
	
2001-12-16  Jan Nieuwenhuizen  <janneke@gnu.org>
 
	* Documentation/topdocs/INSTALL.texi: Added note about broken
	python-2.1.  Updated note for Debian's broken (well, broken for
	our use anyway) tex configuration.
	
	* scripts/lilypond-book.py (re_dict): python2.2 fix.
	
	* stepmake/stepmake/c++-rules.make ($(outdir)/%.hh): 
	($(outdir)/%.cc): Adapted to bison-1.30; added bison < 1.30 fix.
	
	* scripts/lilypond-book.py (bounding_box_dimensions): Bugfix.
	(But left margin of png's still misses a few pixels.  Arg.)
	
2001-12-16  Heikki Junes  <hjunes@cc.hut.fi>

	* lilypond-mode.el (LilyPond-command-next-midi): Make
	possible to kill midi-process (using "C-c C-m").

2001-12-14  Han-Wen  <hanwen@cs.uu.nl>

	* scripts/lilypond-book.py (LatexPaper.set_geo_option):
	Convert strings with dimensions to numbers.

	* lily/volta-engraver.cc:  only make a  bracket for the top staff,
	as found in stavesFound. 

	* lily/bar-number-engraver.cc: remove staff administration. 

	* lily/mark-engraver.cc (acknowledge_grob): remove staff
	administration. This breaks support for invisible-staff.

	* lily/staff-collecting-engraver.cc: new engraver. Collects staff
	symbols into stavesFound.

	* lily/score-engraver.cc (acknowledge_grob): Acknowledge spacing
	grobs, and put them into columns.

	* lily/engraver-group-engraver.cc (acknowledge_grobs): Include the
	Engraver_group_engraver as a potential candidate for ack'ing grobs.

2001-12-13  Heikki Junes  <hjunes@cc.hut.fi>

	* lilypond-mode.el (LilyPond-command-next-midi): Play next (or last)
	midi section in the Emacs-mode, so it is possible to play certain
	score in a multiscore lilypond-file.
	 
2001-12-09  Rune Zedeler  <rune@zedeler.dk>

	* lily/lily-guile.cc: Added ly_assoc_front_x() and ly_assoc_cdr()
	(FIXME: not accessible from guile)
	
	* lily/accidental-engraver.cc: rewrote accidental-routines to get
	better support for Kurt Stone's suggestions.
	Removed properties: noResetKey, forgetAccidentals, autoReminders,
	                    lazyKeySignature.
	Changed property:   localKeySignature.
	Added properties:   extraNatural, autoAccidentals,
	                    autoCautionaries.

	(BUGFIX: broken-tie-support destroyed in 1.5.16)
	
	* ly/property-init.ly: added commands
	\defaultAccidentals \modernAccidentals \modernCautionaries
	\noResetKey \forgetAccidentals

	* ly/engraver-init.ly: Correct initialization of new accidentals.
	
	* scm/translator-property-description.scm: The new properties
	added.
	
	* input/: Some examples added, some changed.
	
	* Documentation/regression-test.tely: Added quick test of new
	accidentals.

2001-12-13  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* scripts/lilypond-book.py (scan_latex_preamble): don't crash if
	header not found

2001-12-07  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/beam.cc (before_line_breaking): Make beams  without stems
	or with only one stem disappear.

2001-12-05  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* bibtools/bib2html.py: Add simple bib2html convertor, and .bst
	files to have standardised HTML bibliography output. Update build
	docs to reflect this.

	* lily/include/simple-spacer.hh (struct Simple_spacer): add
	active_count_, so that we don't have to look for active springs
	anymore.

	* scm/interface-description.scm,scm/grob-property-description.scm:
	Add 'penalty

	* lily/simple-spacer.cc (solve): Handle forced line breaks
	here. Fixes problems when combining linebreaks with non-fitting
	line configurations

2001-12-05  Jan Nieuwenhuizen  <janneke@gnu.org>

	* 1.4.9.jcn3 forward ports.
	
	* Really included .cvsignore.

	* Included Han-Wen's uu1 windows fixes.

	* Bugfix: lilypond-profile.sh: append to GS_FONTPATH, GS_LIB.

	* Added Cygwin setup.hint

	* Removed tex, python wrappers and postinstalls to go with Cywgin's
	tetex/texmf, python installations.

	* Updated cygwin installer.

	* ly2dvi: Don't accept filenames with spaces (+ fix).

2001-12-03  Han-Wen  <hanwen@cs.uu.nl>

	* ly/engraver-init.ly (VoiceContext): fix text engraver ordering.

	* lily/translator-def.cc: Remove manual symbol caching.

	* lily/script-column.cc (before_line_breaking): robustness check:
	don't crash if no direction set.

	* scripts/pmx2ly.py: Key and clef change support (Laura Conrad)

	* scripts/pmx2ly.py (Parser.parse_header): more generic header
	parsing.


2001-12-01  Han-Wen  <hanwen@cs.uu.nl>

	* lily/note-head.cc (head_extent): added to compute width without
	ledger lines. By default, ledger lines take up width now.

	* input/regression/fingering.ly: demonstrate auto fingering.
	Horizontal placement is still buggy. 
	
	* lily/fingering-engraver.cc (class Fingering_engraver):
	added. Provides support for horizontal fingering scripts

	* lily/include/grob.hh: Naming: change parent_l() into get_parent()

	* lily/side-position-interface.cc (add_staff_support): add staff
	only for Y-axis side positions.

	* lily/parser.yy (request_chord): Fix mem leak.

	* lily/musical-request.cc (transpose): moved to Music::transpose()

	* lily/include/grob-info.hh: Change music pointer to SCM, so we
	can store grobs as grob-creation cause as well.

	* lily/group-interface.cc (add_thing): efficiency tweak: reuse
	handle when adding. Use precomputed symbols throughout lily.
	
	* lily/rhythmic-column-engraver.cc: make NoteSpacing grobs to keep
	track of spacing issues.

	* lily/separating-line-group-engraver.cc: make StaffSpacing grobs
	to keep track of staff spacing

2001-11-30  Jan Nieuwenhuizen <janneke@gnu.org>

	* Rewrote new conditional guile >= 1.5 compilation switches, to keep
	  code clean from conditionals and have a concentrated sets of
	  compatibility fixes for old guile versions.

	* Fixes for guile 1.4, including embedded ps.

2001-11-30  Han-Wen Nienhuys  <hanwen@cs.uu.nl>

	* lily/stanza-number-engraver.cc (process_music): allow pairs as
	well for markup texts.

	* lily/musical-request.cc (length_mom): kludge for null pointer.

	* scm/sketch.scm (sketch-output-expression): guile 1.4 compatibility

	* scm/lily.scm (sign): bugfix

	* CHANGES: Change log instated.

	* stepmake/add-html-footer.py: @BRANCH@ tag insertion.

